[![GitHub release (latest by date)](https://img.shields.io/github/v/release/ofmla/seiscope_opt_toolbox_w_ctypes)](https://github.com/ofmla/seiscope_opt_toolbox_w_ctypes/releases/tag/v1.0.1)
![Build Status](https://github.com/ofmla/seiscope_opt_toolbox_w_ctypes/actions/workflows/python.yml/badge.svg)
[![last-commit](https://img.shields.io/github/last-commit/ofmla/seiscope_opt_toolbox_w_ctypes)](https://github.com/ofmla/seiscope_opt_toolbox_w_ctypes/commits/main)
[![DOI](https://zenodo.org/badge/341695999.svg)](https://zenodo.org/badge/latestdoi/341695999)
[![codecov](https://codecov.io/gh/ofmla/seiscope_opt_toolbox_w_ctypes/branch/main/graph/badge.svg?token=BN7NK8A9OJ)](https://codecov.io/gh/ofmla/seiscope_opt_toolbox_w_ctypes)
[![Code style: black](https://img.shields.io/badge/code%20style-black-000000.svg)](https://github.com/psf/black)


# sotb-wrapper: A Python wrapper for the SEISCOPE optimization toolbox (using Ctypes)

This repo demonstrates how it is possible to use the [SEISCOPE optimization toolbox](https://seiscope2.osug.fr/SEISCOPE-OPTIMIZATION-TOOLBOX?lang=fr) (written in Fortran) from Python. The original code is public domain and was written by Ludovic Métivier
and Romain Brossier. Minor changes to the original code have been made to allow the call of the gradient-based optimization subroutines from Python. Such changes and some improvements are listed as follows. 
 * The original source organized in 6 subdirectories (each of which is associated with one gradient-based algorithm) was placed in only one folder in a modular fashion. That is, one module for each optimization algorithm grouping the procedures from each one of the old subdirectories.
 *  The Euclidean vector norm and scalar product calculations were replaced with calls to the intrinsic Fortran ```norm2``` and ```dot_product``` functions, respectively.
 *  Removing Trivial Code Duplication: i.e., same procedures in Steepest Descent and Preconditioned Nonlinear Conjugate Gradient subdirectories.
 *  Removing unused variable declarations.
 *  Vectors of lower and upper bounds (box constraints) are now optional arguments in the optimization subroutines instead of array components of a derived data type

The SEISCOPE toolbox uses a derived data type (`optim`); functionality that is not yet supported at this time by f2py - and for this reason it is used [ctypes](https://docs.python.org/3/library/ctypes.html). The `optim` data type is maintained, but without allocatable arrays.

The repo contains a `src` directory with the modified fortran source files and another named `apps` where each method is used to find the minimum of the banana Rosenbrock function. The python wrapper for the SEISCOPE optimization toolbox is found inside the `sotb_wrapper` directory. A `test` directory includes a script to check that the wrapper has suceeded in reproducing the results of the original fortran code.

## Install Seiscope optimization toolbox (sotb)

If you only want to use the Fortran library, you can simply clone the repo and build it with [Fortran Package Manager](https://github.com/fortran-lang/fpm) or [CMake](https://cmake.org/). In the first case you just need to run 
```bash
fpm build --profile release
```
This command creates the library in static form, as originally designed as well as executable files from demo codes. 

To use `sotb` within your fpm project, add the following to your `fpm.toml` file:

```yml
[dependencies]
sotb = { git="https://github.com/ofmla/seiscope_opt_toolbox_w_ctypes.git" }
```
In the second case, you can run a workflow as the following:
```bash
FC=gfortran cmake -B _build -DCMAKE_INSTALL_PREFIX=$PREFIX -DCMAKE_BUILD_TYPE=Release
cmake --build _build
cmake --install _build
```
where you need to replace `$PREFIX` with the desired directory.

Examples of use of `sotb` can be found in the `app` folder, which contains a folder with an example for each one of the optimization algorithms available in the library. The executable files for each example are built with `cmake` invocation above and made available at `$PREFIX/bin` folder. As mentioned before, when you use `fpm`, executable files for the examples are also created. In this latest case, you can use `fpm run --profile release <test_name>` to run an specific example. So, if you want to run the example that uses the limited-memory version of Broyden-Fletcher-Goldfarb-Shanno (L-BFGS) algorithm, simply run `fpm run --profile release test_LBFGS`. If you run `fpm run --profile release` you can see the names of the six available examples. You can also find a simple example on calling the Fortran subroutines from a C main program in the [`c_code`](https://github.com/ofmla/seiscope_opt_toolbox_w_ctypes/tree/main/examples/c_code) directory. The example uses the L-BFGS to minimize the Rosenbrock's "banana function". Assuming that `$PREFIX` points to the repository root directory, you can create the executable from [`c_code`](https://github.com/ofmla/seiscope_opt_toolbox_w_ctypes/tree/main/examples/c_code) directory, by running 
```bash
cmake -S. -B _build -DCMAKE_PREFIX_PATH="`pwd`/../../"
cmake --build _build
```
or
```bash
cmake -S. -B _build -Dsotb_DIR="`pwd`/../../lib/cmake/sotb"
cmake --build _build
```
## Install the python wrapper of sotb (sotb-wrapper)

To install the Python API with the embedded `sotb` shared library you can use pip.
```bash
pip install sotb-wrapper
```
It is also possible to install directly from the GitHub repository. You will need a Fortran compiler such as GFortran to compile the shared library but the whole process is automated via [scikit-build](https://github.com/scikit-build/scikit-build).
```bash
pip install git+https://github.com/ofmla/seiscope_opt_toolbox_w_ctypes
```
### Usage

The following example demonstrates how to define and solve the classical Rosenbrock problem
```python
import numpy as np
from sotb_wrapper import interface

# Declare the objective function
def rosenbrock(X):
    """
    http://en.wikipedia.org/wiki/Rosenbrock_function
    A generalized implementation is available
    as the scipy.optimize.rosen function
    """
    a = 1. - X[0]
    b = X[1] - X[0]*X[0]
    return a*a + b*b*100., np.array([-a*2. - 400.*X[0]*b, 200.*b], dtype=np.float32)
    
# Create an instance of the SEISCOPE optimization toolbox wrapper (sotb_wrapper) Class. 
sotb = interface.sotb_wrapper()
n = 2 # dimension
flag = 0 # first flag; 0 means initialization
X = np.ones(2, dtype=np.float32)*-1. # initial guess

# computation of the cost and gradient associated with the initial guess
fcost, grad = rosenbrock(X)
# copy of grad in grad_preco: no preconditioning in this test
grad_preco = np.copy(grad)
# Set parameters of the UserDefined derived type in Fortran (ctype structure).
# The first two parameters are mandatory; all others are optional. 
sotb.set_inputs(fcost, 10000, conv=1e-8, l=10)

# optimization loop: while convergence not reached or linesearch not failed, iterate
while (flag != 2 and flag != 4):
    flag = sotb.PSTD(n, X, fcost, grad, grad_preco, flag)
    if flag == 1:
        # compute cost and gradient at point x
        fcost, grad = rosenbrock(X)
        # no preconditioning in this test: simply copy grad in grad_preco
        grad_preco = np.copy(grad)
print('FINAL iterate is : ', X)
```

The code above is part of a tutorial in the form of a Jupyter notebook (`rosenbrock.ipynb`) provided in the [`examples`](https://github.com/ofmla/seiscope_opt_toolbox_w_ctypes/tree/main/examples) subdirectory. The goal of the tutorial is show you how one can use sotb-wrapper to find a minimum for a problem, which can optionally be subject to bound constraints (also called box constraints). The directory also includes examples in the context of geophysical inversion. Note that you must have [Devito](https://www.devitoproject.org/) in order to be able to run them. A python script `plot_curves.py` is also provide in the `examples` directory. It may not be the best implementation and is intended for illustrative purposes only. 

The following figures were obtained with the `plot_curves.py` script after ran one of the examples (`lsrtm_aniso.py`).

<img src="./examples/computationalcost_curves.svg" width="425"/> <img src="./examples/convergence_curves.svg" width="425"/> 

License
-----

sotb-wrapper is distributed under the MIT license. See the included [`LICENSE`](https://github.com/ofmla/seiscope_opt_toolbox_w_ctypes/blob/main/LICENSE.md) file for details.

See also
------
 * SEISCOPE optimization toolbox paper: https://library.seg.org/doi/10.1190/geo2015-0031.1
 * Original source code: http://seiscope2.osug.fr/IMG/tgz/TOOLBOX_22_09_2014_OPTIMIZATION.tgz

!******************************************************************
!Copyright 2013-2016 SEISCOPE II project, All rights reserved.
!
!Redistribution and use in source and binary forms, with or
!without modification, are permitted provided that the following
!conditions are met:
!
!    *  Redistributions of source code must retain the above copyright
!       notice, this list of conditions and the following disclaimer.
!    *  Redistributions in binary form must reproduce the above
!       copyright notice, this list of conditions and the following
!       disclaimer in the documentation and/or other materials provided
!       with the distribution.
!    *  Neither the name of the SEISCOPE project nor the names of
!       its contributors may be used to endorse or promote products
!       derived from this software without specific prior written permission.
!
!Warranty Disclaimer:
!THIS SOFTWARE IS PROVIDED BY THE SEISCOPE PROJECT AND CONTRIBUTORS
!"AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
!LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
!FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
!SEISCOPE PROJECT OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
!INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
!BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
!LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
!CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT,
!STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING
!IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
!POSSIBILITY OF SUCH DAMAGE.

module opt_PSTD
use typedef
use miscellaneous

private
real, allocatable, dimension(:) :: xk, descent
public set_inputs, PSTD, xk, descent

contains

subroutine pstd_centry(n,x,fcost,grad,grad_preco,optim,flag,lb,ub) bind(c, name='PSTD')
  use, intrinsic :: iso_c_binding
  !IN
  integer(c_int), value  :: n                    !dimension of the problem
  real(c_float)   :: fcost                       !cost associated with x
  real(c_float),dimension(n) :: grad,grad_preco !gradient and preconditioned gradient at x 
  !IN/OUT  
  integer(c_int)  :: flag
  real(c_float),dimension(n) :: x               !current point
  type(optim_type) :: optim            !data structure 
  type(c_ptr), value  :: lb,ub
  real(c_float), pointer, dimension(:) :: lb_pass, ub_pass

  nullify(lb_pass)
  nullify(ub_pass)
  if (c_associated(ub)) call c_f_pointer(ub, ub_pass, (/n/))
  if (c_associated(lb)) call c_f_pointer(lb, lb_pass, (/n/))
  call pstd(n,x,fcost,grad,grad_preco,optim,flag,lb_pass,ub_pass)
end subroutine pstd_centry

!*********************************************!
!*    SEISCOPE OPTIMIZATION TOOLBOX          *!
!*********************************************!
! This routine is used to deallocate all the  !
! arrays that have been used during the       !
! PSTD optimization                           !
!---------------------------------------------!
! INPUT/OUT:  optim_type optim                !
!---------------------------------------------!
subroutine finalize_PSTD()
  
  implicit none 
  
  deallocate(xk)
  deallocate(descent)
  
end subroutine finalize_PSTD

!*****************************************************!
!*          SEISCOPE OPTIMIZATION TOOLBOX            *!
!*****************************************************!
! This routine is the reverse communication mode      !
! preconditioned steepest descent algorithm. This     ! 
! routine performs an iterative minimization of a     !
! function f following the recurrence                 !
!                                                     !
! x_{0}=x0                                            !
! x_{k+1}=x_k+\alpha_k d_k                            !
!                                                     !
! where the descent direction d_k is                  !
!                                                     !
! d_k=-Q_k \nabla f_k                                 !
!                                                     !
! with Q_k        : preconditioner at iteration k     !
!      \nabla f_k : gradient of f in x_k              !
!                                                     !
! and alpha_k is the steplength computed through the  !
! common linesearch algorithm of the TOOLBOX          !
!                                                     !
! The first call to the algorithm must be done with   !
! FLAG='INIT'. For this first call, the initial point !
! x0 is given through the variable x, and the input   !
! variable fcost and grad must correspond respectively!
! to the misfit and gradient at x0.                   !
!                                                     !
! The reverse communication with the user is          !
! performed through the variable FLAG. This           !
! variable indicates to the user on return what action! 
! he has to do, or the state of the algorithm.        !
! Possible values are                                 !
! - FLAG='GRAD' => the user must compute the cost and !
!                  (preconditioned) gradient at       !
!                  current point x                    !
! - FLAG='CONV' => a minimizer has been found         !
! - FLAG='NSTE' => a new step is performed            !
! - FLAG='FAIL' => the linesearch has failed          !
!-----------------------------------------------------!
! INPUT  : integer :: n (dimension)                   ! 
!          real fcost (current cost)                  !
!          real,dimension(n) grad                     !
!          real,dimension(n) grad_preco               !
! INPUT/OUTPUT : real,dimension(n) x                  !
!                optim_typ optim (data structure)     !
!                character*4 FLAG (communication)     !
!-----------------------------------------------------!
subroutine PSTD(n,x,fcost,grad,grad_preco,optim,flag,lb,ub)
  use, intrinsic :: iso_c_binding
  implicit none
  
  !IN
  integer  :: n                        !dimension of the problem
  real   :: fcost                      !cost associated with x
  real,dimension(n) :: grad,grad_preco !gradient and preconditioned gradient at x 
  !IN/OUT  
  integer(c_int),intent(inout)  :: flag
  real,dimension(n) :: x               !current point
  real(c_float),optional, dimension(n) :: lb,ub
  type(optim_type) :: optim            !data structure   
  !Local variable
  logical :: test_conv

  if(FLAG.eq. 0) then     
     !-----------------------------------------------------!
     ! if FLAG is INIT, call the dedicated initialization  !
     ! subroutine to allocate data structure optim and     !
     ! initialize the linesearch process                   !
     !-----------------------------------------------------!
     !call init_PSTD(n,x,fcost,grad_preco,optim)
     allocate(xk(n), descent(n))
     xk(:)=x(:)
     descent(:)=-1.*grad_preco(:)
     call std_linesearch(n,x,fcost,grad,xk,descent,optim,lb,ub)
     call print_info(n,'ST',optim,fcost,grad,flag)
     FLAG=1     
     optim%nfwd_pb=optim%nfwd_pb+1
  else
     !-----------------------------------------------------!
     ! else call the linesearch process                    !  
     !-----------------------------------------------------!
     call std_linesearch(n,x,fcost,grad,xk,descent,optim,lb,ub)
     if(optim%task.eq.0) then !NEW STEP
        !-----------------------------------------------------!
        ! test for convergence                                !
        !-----------------------------------------------------!        
        optim%cpt_iter=optim%cpt_iter+1        
        call std_test_conv(optim,fcost,test_conv)
        if(test_conv) then
           FLAG=2
           call print_info(n,'ST',optim,fcost,grad,flag)
           call finalize_PSTD
        else
           FLAG=3
           !-----------------------------------------------------!
           ! if a NEW_STEP is taken, compute a new descent       !
           ! direction using current descent, gradient and       !
           ! preconditioned gradient                             !          
           !-----------------------------------------------------!
           descent(:)=-1.*grad_preco(:)                
           !print info on current iteration           
           call print_info(n,'ST',optim,fcost,grad,flag)
        endif
     elseif(optim%task.eq. 1) then
        !-----------------------------------------------------!
        ! if the linesearch needs a new gradient then ask the !  
        ! user to provide it
        !-----------------------------------------------------!
        FLAG=1         
        optim%nfwd_pb=optim%nfwd_pb+1
     elseif(optim%task.eq. 2) then
        !-----------------------------------------------------!
        ! if the linesearch has failed, inform the user       !
        !-----------------------------------------------------!
        FLAG=4
        !print info on current iteration
        call print_info(n,'ST',optim,fcost,grad,flag)
        call finalize_PSTD
     endif
  endif
  
end subroutine PSTD

end module opt_PSTD

!******************************************************************
!Copyright 2013-2016 SEISCOPE II project, All rights reserved.
!
!Redistribution and use in source and binary forms, with or
!without modification, are permitted provided that the following
!conditions are met:
!
!    *  Redistributions of source code must retain the above copyright
!       notice, this list of conditions and the following disclaimer.
!    *  Redistributions in binary form must reproduce the above
!       copyright notice, this list of conditions and the following
!       disclaimer in the documentation and/or other materials provided
!       with the distribution.
!    *  Neither the name of the SEISCOPE project nor the names of
!       its contributors may be used to endorse or promote products
!       derived from this software without specific prior written permission.
!
!Warranty Disclaimer:
!THIS SOFTWARE IS PROVIDED BY THE SEISCOPE PROJECT AND CONTRIBUTORS
!"AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
!LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
!FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
!SEISCOPE PROJECT OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
!INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
!BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
!LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
!CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT,
!STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING
!IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
!POSSIBILITY OF SUCH DAMAGE.

module opt_PLBFGS
use, intrinsic :: iso_c_binding
use typedef
use miscellaneous
use opt_PSTD, only : xk, descent
use opt_LBFGS, only : save_LBFGS, update_LBFGS, sk, yk

private
real, allocatable, dimension(:) :: alpha_plb,rho_plb
public PLBFGS

contains

subroutine plbfgs_centry(n,x,fcost,grad,grad_preco,q_plb,optim,flag,lb,ub) bind(c, name='PLBFGS')
  !IN
  integer(c_int), value  :: n                    !dimension of the problem
  real(c_float)   :: fcost                       !cost associated with x
  real(c_float),dimension(n) :: grad,grad_preco !gradient and preconditioned gradient at x 
  real(c_float),dimension(n) :: q_plb
  !IN/OUT  
  integer(c_int)  :: flag
  real(c_float),dimension(n) :: x               !current point
  type(optim_type) :: optim            !data structure 
  type(c_ptr), value  :: lb,ub
  real(c_float), pointer, dimension(:) :: lb_pass, ub_pass

  nullify(lb_pass)
  nullify(ub_pass)
  if (c_associated(ub)) call c_f_pointer(ub, ub_pass, (/n/))
  if (c_associated(lb)) call c_f_pointer(lb, lb_pass, (/n/))
  call plbfgs(n,x,fcost,grad,grad_preco,q_plb,optim,flag,lb_pass,ub_pass)
end subroutine plbfgs_centry

!*****************************************************!
!*          SEISCOPE OPTIMIZATION TOOLBOX            *!
!*****************************************************!
! This file contains the two parts of the computation !
! of the l-BFGS descent direction following the two   !
! recursion loop algorithm                            ! 
! Nocedal, 2nd edition, 2006 Algorithm 7.5 p. 179     !
! Basically, the two loops have been split, compared  !
! to the standard l-BFGS algorithm, to allow the user !
! to use its preconditioner as an initial estimation  !
! of the inverse Hessian operator                     ! 
!-----------------------------------------------------!

!-----------------------------------------------------!
!FIRST LOOP: descent1_PLBFGS                          !
!------------------------------------------------------
! INPUT : integer n dimension                         !
!         real,dimension(n) grad current gradient     !
!         real,dimension(n,l) sk yk pairs of vectors  !
!                             for l-BFGS approximation!
!         integer cpt_lbfgs current number of stored  !
!                           pairs                     !
!         integer l maximum number of stored pairs    !
! OUTPUT : real,dimension(n) descent                  !
!-----------------------------------------------------!
subroutine descent1_PLBFGS(n,grad,sk,yk,cpt_lbfgs,l,q_plb)
  
  implicit none

  !IN
  integer :: n,cpt_lbfgs,l
  real,dimension(n) :: grad, q_plb
  real,dimension(n,l) :: sk,yk
  !Local variables
  integer :: i,borne_i
  
  borne_i=cpt_lbfgs-1
  allocate(alpha_plb(cpt_lbfgs))
  allocate(rho_plb(cpt_lbfgs))  
  q_plb(:)=grad(:)
  do i=1,borne_i
     rho_plb(borne_i-i+1)= dot_product(yk(:,borne_i-i+1),sk(:,borne_i-i+1))
     rho_plb(borne_i-i+1)=1./rho_plb(borne_i-i+1)
     alpha_plb(borne_i-i+1)= dot_product (sk(:,borne_i-i+1),q_plb(:))
     alpha_plb(borne_i-i+1)=rho_plb(borne_i-i+1)*alpha_plb(borne_i-i+1)
     q_plb(:)=q_plb(:)-alpha_plb(borne_i-i+1)*yk(:,borne_i-i+1)
  enddo
  
end subroutine descent1_PLBFGS

!-----------------------------------------------------!
!SECOND LOOP: descent2_PLBFGS                         !
!------------------------------------------------------
! INPUT : integer n dimension                         !
!         real,dimension(n) grad current gradient     !
!         real,dimension(n,l) sk yk pairs of vectors  !
!                             for l-BFGS approximation!
!         integer cpt_lbfgs current number of stored  !
!                           pairs                     !
!         integer l maximum number of stored pairs    !
! OUTPUT : real,dimension(n) descent                  !
!-----------------------------------------------------!
subroutine descent2_PLBFGS(n,sk,yk,cpt_lbfgs,l,descent,q_plb)
  
  implicit none
  
  !IN
  integer :: n,cpt_lbfgs,l
  real,dimension(n,l) :: sk,yk
  !IN/OUT
  real,dimension(n) :: descent, q_plb
  !Local variables
  real :: beta,gamma,gamma_num,gamma_den
  integer :: i,borne_i
  
  borne_i=cpt_lbfgs-1  
  gamma_num = dot_product(sk(:,borne_i),yk(:,borne_i))
  gamma_den = norm2 (yk(:,borne_i))
  gamma=gamma_num/(gamma_den**2)     
  descent(:)=gamma*q_plb(:)
  do i=1,borne_i
     beta = dot_product(yk(:,i),descent(:))
     beta= rho_plb(i)*beta
     descent(:)=descent(:)+(alpha_plb(i)-beta)*sk(:,i)
  enddo
  descent(:)=-1.*descent(:)
  deallocate(alpha_plb,rho_plb)
  
end subroutine descent2_PLBFGS
!*********************************************!
!*    SEISCOPE OPTIMIZATION TOOLBOX          *!
!*********************************************!
! This routine is used to deallocate all the  !
! arrays that have been used during the       !
! PSTD optimization                           !
!---------------------------------------------!
! INPUT/OUT:  optim_type optim                !
!---------------------------------------------!
subroutine finalize_PLBFGS()
  
  implicit none 
  
  deallocate(xk)
  deallocate(descent)
  deallocate(sk)
  deallocate(yk)  
  
end subroutine finalize_PLBFGS

!*****************************************************!
!*          SEISCOPE OPTIMIZATION TOOLBOX            *!
!*****************************************************!
! This routine is the reverse communication mode      !
! preconditioned l-BFGS algorithm. This algorithm is  !
! described in :                                      !
! Numerical Optimization, Nocedal, 2nd edition, 2006  !
! Algorithm 7.4 p. 178, Algorithm 7.5 p. 179          !
!                                                     !
! This routine performs an iterative                  !
! minimization of a function f following the          !
! recurrence                                          !
!                                                     !
! x_{0}=x0                                            !
! x_{k+1}=x_k+\alpha_k d_k                            !
!                                                     !
! where the descent direction d_k is                  !
!                                                     !
! d_k=-Q_k \nabla f_k                                 !
!                                                     !
! with Q_k        : l-BFGS approximation of the       !
!                   inverse Hessian at iteration k    !
!                   including preconditioning info    !
!\nabla f_k       : gradient of f in x_k              !
!                                                     !
! and alpha_k is the steplength computed through the  !
! common linesearch algorithm of the TOOLBOX          !
!                                                     !
! The only difference with the l-BFGS algorithm is in !
! the computation of the descent direction d_k which  !
! can now include a prior information on the inverse  !
! hessian operator.                                   !
!                                                     !
! The first call to the algorithm must be done with   !
! FLAG='INIT'. For this first call, the initial point !
! x0 is given through the variable x, and the input   !
! variable fcost and grad must correspond respectively!
! to the misfit and gradient at x0.                   !
!                                                     !
! The reverse communication with the user is          !
! performed through the variable FLAG. This           !
! variable indicates to the user on return what action! 
! he has to do, or the state of the algorithm.        !
! Possible values are                                 !
! - FLAG='GRAD' => the user must compute the cost and !
!                  (preconditioned) gradient at       !
!                  current point x                    !
! - FLAG='PREC' => the user must multiply the vector   !
!                  optim%q_plb by its preconditioner  !
! - FLAG='CONV' => a minimizer has been found         !
! - FLAG='NSTE' => a new step is performed            !
! - FLAG='FAIL' => the linesearch has failed          !
!-----------------------------------------------------!
! INPUT  : integer :: n (dimension)                   ! 
!          real fcost (current cost)                  !
!          real,dimension(n) grad                     !
!          real,dimension(n) grad_preco               !
! INPUT/OUTPUT : real,dimension(n) x                  !
!                optim_typ optim (data structure)     !
!                character*4 FLAG (communication)     !
!-----------------------------------------------------!
subroutine PLBFGS(n,x,fcost,grad,grad_preco,q_plb,optim,flag,lb,ub)
  
  implicit none
  
  !IN
  integer  :: n                            !dimension of the problem
  real :: fcost                          !cost associated with x
  real,dimension(n) :: grad              !associated gradient 
  real,dimension(n) :: grad_preco        !preconditioned gradient (first iteration only) 
  real,dimension(n) :: q_plb
  !IN/OUT  
  integer  :: flag
  real,dimension(n) :: x          !current point
  type(optim_type) :: optim                !data structure
  real(c_float),optional, dimension(n) :: lb,ub 
  !Local variables
  logical :: test_conv
  
  if(FLAG.eq. 0) then
     !-----------------------------------------------------!
     ! if FLAG is INIT, call the dedicated initialization  !
     ! subroutine to allocate data structure optim and     !
     ! initialize the linesearch process                   !
     !-----------------------------------------------------!
     !call init_PLBFGS(n,optim%l,x,fcost,grad,grad_preco,optim)
     allocate(sk(n,optim%l), yk(n,optim%l), xk(n), descent(n))
     sk(:,:)=0.
     yk(:,:)=0.
     xk(:)=x(:)
     descent(:)=-1.*grad_preco(:)
     call save_LBFGS(n,optim%cpt_lbfgs,optim%l,x,grad,sk,yk)
     call std_linesearch(n,x,fcost,grad,xk,descent,optim,lb,ub)
     call print_info(n,'PL',optim,fcost,grad,FLAG)
     FLAG=1     
     optim%nfwd_pb=optim%nfwd_pb+1
  elseif(FLAG.eq. 5) then
     !-----------------------------------------------------!
     ! if FLAG is PREC, we return from a call to the       !
     ! user preconditioner, then we have to finish the     !
     ! computation of the descent direction                !
     !-----------------------------------------------------!
     call descent2_PLBFGS(n,sk,yk,optim%cpt_lbfgs,&
          optim%l,descent,q_plb)         
     !LBFGS save
     call save_LBFGS(n,optim%cpt_lbfgs,optim%l,x,grad,sk,yk)
     optim%cpt_iter=optim%cpt_iter+1        
     !-----------------------------------------------------!
     ! before continuing we test for convergence           !
     !-----------------------------------------------------!
     call std_test_conv(optim,fcost,test_conv)
     if(test_conv) then
        FLAG=2
        !print info on current iteration
        call print_info(n,'PL',optim,fcost,grad,FLAG)
        call finalize_PLBFGS
     else
        FLAG=3
        !print info on current iteration
        call print_info(n,'PL',optim,fcost,grad,FLAG)
     endif
  else
     !-----------------------------------------------------!
     ! else call the linesearch process                    !  
     !-----------------------------------------------------!
     call std_linesearch(n,x,fcost,grad,xk,descent,optim,lb,ub)     
     if(optim%task.eq. 0) then 
        !LBFGS update        
        call update_LBFGS(n,optim%cpt_lbfgs,optim%l,x,grad,sk,yk)
        !Start the computation of the new descent direction
        call descent1_PLBFGS(n,grad,sk,yk,optim%cpt_lbfgs,optim%l,q_plb)         
        !Set FLAG to PREC for asking user to perform preconditioning 
        FLAG=5                        
     elseif(optim%task.eq. 1) then 
        !-----------------------------------------------------!
        ! if the linesearch needs a new gradient then ask the !  
        ! user to provide it
        !-----------------------------------------------------!
        FLAG=1
        optim%nfwd_pb=optim%nfwd_pb+1
     elseif(optim%task.eq. 2) then        
        !-----------------------------------------------------!
        ! if the linesearch has failed, inform the user       !
        !-----------------------------------------------------!
        FLAG=4
        !print info on current iteration
        call print_info(n,'PL',optim,fcost,grad,FLAG)
        call finalize_PLBFGS
     endif
  endif
  
end subroutine PLBFGS

end module opt_PLBFGS

!******************************************************************
!Copyright 2013-2016 SEISCOPE II project, All rights reserved.
!
!Redistribution and use in source and binary forms, with or
!without modification, are permitted provided that the following
!conditions are met:
!
!    *  Redistributions of source code must retain the above copyright
!       notice, this list of conditions and the following disclaimer.
!    *  Redistributions in binary form must reproduce the above
!       copyright notice, this list of conditions and the following
!       disclaimer in the documentation and/or other materials provided
!       with the distribution.
!    *  Neither the name of the SEISCOPE project nor the names of
!       its contributors may be used to endorse or promote products
!       derived from this software without specific prior written permission.
!
!Warranty Disclaimer:
!THIS SOFTWARE IS PROVIDED BY THE SEISCOPE PROJECT AND CONTRIBUTORS
!"AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
!LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
!FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
!SEISCOPE PROJECT OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
!INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
!BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
!LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
!CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT,
!STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING
!IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
!POSSIBILITY OF SUCH DAMAGE.

!*****************************************************!
!*          SEISCOPE OPTIMIZATION TOOLBOX            *!
!*****************************************************!
! This program provides an example for using the      !
! preconditioned truncated Newton algorithm within the!
! SEISCOPE OPTIMIZATION TOOLBOX.                      !
!                                                     !
! The algorithm implemented is described in           !
! L.Metivier, R. Brossier, J. Virieux, S.Operto,      !
! Truncated Newton and full waveform inversion, 2013  !
! SIAM Journal on Scientific Computing, Vol. 35,      !
! No. 2, pp. B401–B437,                               !         
!                                                     !
! The 2D Rosenbrock function is minimized             !
! f(x,y)  = (1-x)**2+100.*(y-x**2)**2                 !
!                                                     !
! The computation of this function and its gradient   !
! is implemented in                                   !
! ../../../COMMON/test/rosenbrock.f90                 !
! routine rosenbrock                                  !
!                                                     !
! The preconditioned truncated Newton method also     !
! requires to compute Hessian-vector products. This   !
! is implemented in                                   ! 
! ../../../COMMON/test/rosenbrock.f90                 !
! routine rosenbrok_hess                              !
!                                                     !
! The communication with the PTRN optimizer is        ! 
! achieved through the variable FLAG. The only        !
! difference with the TRN optimizer is that a         !
! preconditioner can be used to improve the           !
! convergence speed of the inner conjugate gradient   !
! iterations. This preconditioner is applied to the   !
! gradient, and to the residual of the inner linear   !
! system.  
!                                                     !
! Here are the actions requested for the user         !
! 1. Before first call, the user must set the         !
!    optimization parameters, namely                  !
!    - maximum number of iterations optim%niter_max   !
!    - tolerance for the stopping criterion           !
!      optim%conv                                     !
!      (this stopping criterion is the default one    !
!        in the TOOLBOX and is based on the decrease  !
!        of the misfit function scaled to one at the  !
!        first iteration)                             !
!     - level of details in the output                !
!       * if optim%debug=.true. then the information  !
!         on the linesearch process is provided       !
!         additional information related to the       !
!         quadratic function minimized throughout the !
!         inner conjugate gradient iterations is also !
!         provided as a quality control               !
!       * if optim%debug=.false. a more compact output!
!         file is provided                            !
!   - initialize x with an arbitrary initial guess    !
!   - initialize fcost with the cost function         !
!     associated with the initial guess               !
!   - initialize grad with the gradient associated    !
!     with the initial guess                          !
!   - initialize grad_preco with the gradient         !
!     associated with the initial guess multiplied by !
!     the preconditioner                              !
! 2. On first call, FLAG must be set to INIT          !
! 3. When the FLAG returned by PTRN is 'GRAD', then   !
!    the user must compute the cost, the gradient     !
!    and the preconditioned gradient at current       !
!    iterate x in fcost, grad, grad_preco             !
! 4. When the FLAG returned by PTRN is 'PREC', then   !
!    multiply the vector optim%residual by the        !
!    preconditioner and store the result in           !
!    optim%residual_preco                             !
! 5. When the FLAG returned by PTRN is 'HESS', then   !
!    multiply the vector optim%d by the Hessian       !
!    and store the result in optim%Hd                 ! 
!-----------------------------------------------------!
program test_PTRN
  !use typedef
  !use opt_PTRN
  use seiscope_optimization_toolbox
  implicit none  
  
  integer :: n                                ! dimension of the problem
  real :: fcost                               ! cost function value
  real,dimension(:),allocatable :: x          ! current point
  real,dimension(:),allocatable :: grad       ! current gradient
  real,dimension(:),allocatable :: grad_preco ! preconditioned current gradient
  real,dimension(:),allocatable :: d, Hd
  real,dimension(:),allocatable :: residual,residual_preco
  type(optim_type) :: optim                   ! data structure for the optimizer
  !character*4 :: FLAG                         ! communication FLAG 
  integer :: FLAG                             ! communication FLAG
  

  !----------------------------------------------------!
  ! Set size of one-dimensional solution array and     !
  ! first flag value                                   !
  !----------------------------------------------------!
  n=2     ! dimension
  FLAG=0  ! first flag -- 'INIT' in original version
  
  !----------------------------------------------------!
  ! intial guess                                       !
  !----------------------------------------------------!
  allocate(x(n),grad(n),grad_preco(n),d(n),Hd(n))
  allocate(residual(n),residual_preco(n))
  x(1)=1.5
  x(2)=1.5
  
  !----------------------------------------------------!
  ! computation of the cost and gradient associated    !
  ! with the initial guess                             !
  !----------------------------------------------------!
  call Rosenbrock(x,fcost,grad)

  !----------------------------------------------------!
  ! multiplication of the gradient by the              !
  ! preconditioner (here preconditioner is identity:   !
  ! no preconditioning)                                !
  !----------------------------------------------------!
  grad_preco(:)=grad(:)  
  
  !----------------------------------------------------!
  ! parameter initialization (i.e., maximum iteration  !
  ! number, tolerance for stopping criterion, print    !
  ! info in output files, etc)                         !
  !----------------------------------------------------!
  call set_inputs(optim, fcost, 100, 1., 20, 1e-8, &
                  l=20, niter_max_CG=5)
                  
  !----------------------------------------------------!
  ! optimization loop: while convergence not reached or!
  ! linesearch not failed, iterate                     !
  !----------------------------------------------------!
  !do while ((FLAG.ne.'CONV').and.(FLAG.ne.'FAIL'))
  do while ((FLAG.ne.2).and.(FLAG.ne.4)) 
     call PTRN(n,x,fcost,grad,grad_preco,residual,residual_preco, &
               d,Hd,optim,FLAG)
     !if(FLAG.eq.'GRAD') then   
     if(FLAG.eq. 1) then                   
        !----------------------------------------------------!
        ! if FLAG is GRAD, then compute cost, gradient and   !
        ! preconditioned gradient in fcost, grad, grad_preco !
        !----------------------------------------------------!
        call Rosenbrock(x,fcost,grad)        
        grad_preco(:)=grad(:)
     !elseif(FLAG.eq.'HESS') then
     elseif(FLAG.eq. 7) then
        !----------------------------------------------------!
        ! if FLAG is HESS, then multiply optim%d by the      !
        ! Hessian operator and store the result in optim%Hd  !
        !----------------------------------------------------!
        call Rosenbrock_Hess(x,d,Hd)
     !elseif(FLAG.eq.'PREC') then
     elseif(FLAG.eq. 8) then
        !----------------------------------------------------!
        ! if FLAG is PREC, then multiply optim%residual by   !
        ! preconditioner and store the result in             !
        ! optim%residual_preco                               !
        !----------------------------------------------------!
        residual_preco(:)=residual(:)
     endif
  enddo
  
  !Helpful console writings
  write(*,*) 'END OF TEST'
  write(*,*) 'FINAL iterate is : ', x(:)
  write(*,*) 'See the convergence history in iterate_PTRN.dat and iterate_PTRN_CG.dat'
  
end program test_PTRN

!******************************************************************
!Copyright 2013-2016 SEISCOPE II project, All rights reserved.
!
!Redistribution and use in source and binary forms, with or
!without modification, are permitted provided that the following
!conditions are met:
!
!    *  Redistributions of source code must retain the above copyright
!       notice, this list of conditions and the following disclaimer.
!    *  Redistributions in binary form must reproduce the above
!       copyright notice, this list of conditions and the following
!       disclaimer in the documentation and/or other materials provided
!       with the distribution.
!    *  Neither the name of the SEISCOPE project nor the names of
!       its contributors may be used to endorse or promote products
!       derived from this software without specific prior written permission.
!
!Warranty Disclaimer:
!THIS SOFTWARE IS PROVIDED BY THE SEISCOPE PROJECT AND CONTRIBUTORS
!"AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
!LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
!FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
!SEISCOPE PROJECT OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
!INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
!BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
!LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
!CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT,
!STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING
!IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
!POSSIBILITY OF SUCH DAMAGE.

module opt_LBFGS
use typedef
use miscellaneous
use opt_PSTD, only : xk, descent

private
real, allocatable, dimension(:,:) :: sk,yk
public LBFGS, save_LBFGS, update_LBFGS, sk, yk

contains

subroutine lbfgs_centry(n,x,fcost,grad,optim,flag,lb,ub) bind(c, name='LBFGS')
  use, intrinsic :: iso_c_binding
  !IN
  integer(c_int), value  :: n                    !dimension of the problem
  real(c_float)   :: fcost                       !cost associated with x
  real(c_float),dimension(n) :: grad             !gradient at x 
  !IN/OUT  
  integer(c_int)  :: flag
  real(c_float),dimension(n) :: x               !current point
  type(optim_type) :: optim                     !data structure 
  type(c_ptr), value  :: lb,ub
  real(c_float), pointer, dimension(:) :: lb_pass, ub_pass

  nullify(lb_pass)
  nullify(ub_pass)
  if (c_associated(ub)) call c_f_pointer(ub, ub_pass, (/n/))
  if (c_associated(lb)) call c_f_pointer(lb, lb_pass, (/n/))
  call lbfgs(n,x,fcost,grad,optim,flag,lb_pass,ub_pass)
end subroutine lbfgs_centry

!*****************************************************!
!*          SEISCOPE OPTIMIZATION TOOLBOX            *!
!*****************************************************!
! This routines is used by the l-BFGS routine to      !
! compute l-BFGS descent direction following the two  !
! recursion loop algorithm                            ! 
! Nocedal, 2nd edition, 2006 Algorithm 7.5 p. 179     !
!-----------------------------------------------------!
! INPUT : integer n dimension                         !
!         real,dimension(n) grad current gradient     !
!         real,dimension(n,l) sk yk pairs of vectors  !
!                             for l-BFGS approximation!
!         integer cpt_lbfgs current number of stored  !
!                           pairs                     !
!         integer l maximum number of stored pairs    !
! OUTPUT : real,dimension(n) descent                  !
!-----------------------------------------------------!
subroutine descent_LBFGS(n,grad,sk,yk,cpt_lbfgs,l,descent)
  
  implicit none
  
  !IN
  integer :: n,cpt_lbfgs,l
  real,dimension(n) :: grad
  real,dimension(n,l) :: sk,yk
  !IN/OUT
  real,dimension(n) :: descent
  !Local variables
  real,dimension(:),allocatable :: q
  real,dimension(:),allocatable :: alpha,rho
  real :: beta,gamma,gamma_num,gamma_den
  real :: norml2_yk,norml2_sk
  integer :: i,borne_i
  
  borne_i=cpt_lbfgs-1
  
  !------------------------------------------!
  ! SAFEGUARD                                !
  !------------------------------------------!
  norml2_sk = norm2(sk(:,borne_i))
  norml2_yk = norm2(yk(:,borne_i))
  if( (norml2_sk==0.).or.(norml2_yk==0.)) then
     descent(:)=-1.*grad(:)     
  else
     !------------------------------------------!
     ! First phase of the recursion loop        !
     !------------------------------------------!
     allocate(alpha(cpt_lbfgs))
     allocate(rho(cpt_lbfgs))
     allocate(q(n))
     q(:)=grad(:)
     do i=1,borne_i
        rho(borne_i-i+1) = dot_product(yk(:,borne_i-i+1),sk(:,borne_i-i+1))
        rho(borne_i-i+1)=1./rho(borne_i-i+1)
        alpha(borne_i-i+1) = dot_product(sk(:,borne_i-i+1),q(:))
        alpha(borne_i-i+1)=rho(borne_i-i+1)*alpha(borne_i-i+1)
        q(:)=q(:)-alpha(borne_i-i+1)*yk(:,borne_i-i+1)
     enddo
     gamma_num = dot_product(sk(:,borne_i),yk(:,borne_i))
     gamma_den = norm2(yk(:,borne_i))
     !------------------------------------------!
     ! Scaling by gamma                         !
     !------------------------------------------!
     gamma=gamma_num/(gamma_den**2)     
     descent(:)=gamma*q(:)
     !------------------------------------------!
     ! Second phase of the recursion loop       !
     !------------------------------------------!
     do i=1,borne_i
        beta = dot_product(yk(:,i),descent(:))
        beta=rho(i)*beta
        descent(:)=descent(:)+(alpha(i)-beta)*sk(:,i)
     enddo
     descent(:)=-1.*descent(:)
     deallocate(q,alpha,rho)
  endif
  
end subroutine descent_LBFGS
!*********************************************!
!*    SEISCOPE OPTIMIZATION TOOLBOX          *!
!*********************************************!
! This routine is used to deallocate all the  !
! arrays that have been used during the       !
! PSTD optimization                           !
!---------------------------------------------!
! INPUT/OUT:  optim_type optim                !
!---------------------------------------------!
subroutine finalize_LBFGS()
  
  implicit none  
  
  deallocate(sk)
  deallocate(yk)
  deallocate(xk)
  !deallocate(optim%grad)
  deallocate(descent)
  
end subroutine finalize_LBFGS

!*****************************************************!
!*          SEISCOPE OPTIMIZATION TOOLBOX            *!
!*****************************************************!
! This routine is the reverse communication mode      !
! l-BFGS algorithm. This algorithm is described in    !
! Numerical Optimization, Nocedal, 2nd edition, 2006  !
! Algorithm 7.4 p. 178, Algorithm 7.5 p. 179          !
!                                                     !
! This routine performs an iterative                  !
! minimization of a function f following the          !
! recurrence                                          !
!                                                     !
! x_{0}=x0                                            !
! x_{k+1}=x_k+\alpha_k d_k                            !
!                                                     !
! where the descent direction d_k is                  !
!                                                     !
! d_k=-Q_k \nabla f_k                                 !
!                                                     !
! with Q_k        : l-BFGS approximation of the       !
!                   inverse Hessian at iteration k    !
!\nabla f_k       : gradient of f in x_k              !
!                                                     !
! and alpha_k is the steplength computed through the  !
! common linesearch algorithm of the TOOLBOX          !
!                                                     !
! The first call to the algorithm must be done with   !
! FLAG='INIT'. For this first call, the initial point !
! x0 is given through the variable x, and the input   !
! variable fcost and grad must correspond respectively!
! to the misfit and gradient at x0.                   !
!                                                     !
! The reverse communication with the user is          !
! performed through the variable FLAG. This           !
! variable indicates to the user on return what action! 
! he has to do, or the state of the algorithm.        !
! Possible values are                                 !
! - FLAG='GRAD' => the user must compute the cost and !
!                  (preconditioned) gradient at       !
!                  current point x                    !
! - FLAG='CONV' => a minimizer has been found         !
! - FLAG='NSTE' => a new step is performed            !
! - FLAG='FAIL' => the linesearch has failed          !
!-----------------------------------------------------!
! INPUT  : integer :: n (dimension)                   ! 
!          real fcost (current cost)                  !
!          real,dimension(n) grad                     !
! INPUT/OUTPUT : real,dimension(n) x                  !
!                optim_type optim (data structure)    !
!                character*4 FLAG (communication)     !
!-----------------------------------------------------!
subroutine LBFGS(n,x,fcost,grad,optim,flag,lb,ub) 
  use, intrinsic :: iso_c_binding
  implicit none
  
  !IN
  integer  :: n                         !dimension of the problem
  integer  :: l                         !number of stored pairs for the 
                                               !l-BFGS approximation of the 
                                               !inverse Hessian
  real :: fcost                         !cost associated with x
  real,dimension(n) :: grad             !associated gradient 
  !IN/OUT  
  integer  :: flag
  real,dimension(n) :: x                !current point
  type(optim_type) :: optim             !data structure 
  real(c_float),optional, dimension(n) :: lb,ub 
  !Local variables
  logical :: test_conv

  if(FLAG.eq. 0) then
     !-----------------------------------------------------!
     ! if FLAG is INIT, call the dedicated initialization  !
     ! subroutine to allocate data structure optim and     !
     ! initialize the linesearch process                   !
     !-----------------------------------------------------!
     !call init_LBFGS(n,optim%l,x,fcost,grad,optim)
     allocate(sk(n,optim%l), yk(n,optim%l), xk(n), descent(n))
     sk(:,:)=0.
     yk(:,:)=0.
     xk(:)=x(:)
     descent(:)=-1.*grad(:)
     call save_LBFGS(n,optim%cpt_lbfgs,optim%l,x,grad,sk,yk)
     call std_linesearch(n,x,fcost,grad,xk,descent,optim,lb,ub)
     call print_info(n,'LB',optim,fcost,grad,FLAG)
     FLAG=1    
     optim%nfwd_pb=optim%nfwd_pb+1
  else
     !-----------------------------------------------------!
     ! else call the linesearch process                    !  
     !-----------------------------------------------------!
     call std_linesearch(n,x,fcost,grad,xk,descent,optim,lb,ub)     
     if(optim%task.eq. 0) then
        !-----------------------------------------------------!
        ! test for convergence                                !
        !-----------------------------------------------------!
        optim%cpt_iter=optim%cpt_iter+1                   
        call std_test_conv(optim,fcost,test_conv)
        if(test_conv) then
           FLAG=2           
           !print info on current iteration
           call print_info(n,'LB',optim,fcost,grad,FLAG)        
           call finalize_LBFGS()
        else
           FLAG=3
           !-----------------------------------------------------!
           ! if a NEW_STEP is taken, compute a new descent       !
           ! direction using current gradient and l-BFGS         !
           ! approximation of the inverse Hessian                !
           ! preconditioned gradient                             !
           !-----------------------------------------------------!
           !LBFGS update 
           call update_LBFGS(n,optim%cpt_lbfgs,optim%l,x,grad,sk,yk)
           !Computation of the new descent direction
           call descent_LBFGS(n,grad,sk,yk,optim%cpt_lbfgs,&
                l,descent)         
           !LBFGS store
           call save_LBFGS(n,optim%cpt_lbfgs,optim%l,x,grad,sk,yk)           
           !print info on current iteration
           call print_info(n,'LB',optim,fcost,grad,FLAG)        
        endif
     elseif(optim%task.eq. 1) then 
        !-----------------------------------------------------!
        ! if the linesearch needs a new gradient then ask the !  
        ! user to provide it
        !-----------------------------------------------------!
        FLAG=1         
        optim%nfwd_pb=optim%nfwd_pb+1        
     elseif(optim%task.eq. 2) then        
        !-----------------------------------------------------!
        ! if the linesearch has failed, inform the user       !
        !-----------------------------------------------------!
        FLAG=4
        !print info on current iteration
        call print_info(n,'LB',optim,fcost,grad,FLAG)
        call finalize_LBFGS
     endif
  endif
  
end subroutine LBFGS



!*****************************************************!
!*          SEISCOPE OPTIMIZATION TOOLBOX            *!
!*****************************************************!
! This routines is used by the l-BFGS routine to      !
! save the pairs of models and gradient for        !
! the inverse Hessian approximation                   !
! Nocedal, 2nd edition, 2006 Algorithm 7.5 p. 179     !
!-----------------------------------------------------!
! INPUT : integer n dimension                         !
!         integer cpt_lbfgs counts the number of      ! 
!                           already stored pairs      !
!         integer l maximum number of stored pairs    !
!         real,dimension(n) x current point           !
!         real,dimension(n) x current gradient        !
! OUTPUT : sk,yk updated vector                       !
!-----------------------------------------------------!
subroutine save_LBFGS(n,cpt_lbfgs,l,x,grad,sk,yk)
  
  implicit none
  
  !IN
  integer :: n,cpt_lbfgs,l
  real,dimension(n) :: x,grad
  !IN/OUT
  real,dimension(n,l) :: sk,yk
  
  !Local variables
  integer :: i
  
  if(cpt_lbfgs.le.l) then
     !---------------------------------------------------!
     ! if the number of stored pairs does not exceed the !
     ! maximum value, then save x and grad               !
     !---------------------------------------------------!
     sk(:,cpt_lbfgs)=x(:)
     yk(:,cpt_lbfgs)=grad(:)   
  else
     !---------------------------------------------------!
     ! otherwise, erase the oldest pair and save the     !
     ! new one (shift)                                   !
     !---------------------------------------------------!
     do i=1,l-1
        sk(:,i)=sk(:,i+1)
        yk(:,i)=yk(:,i+1)                
     enddo
     sk(:,l)=x(:)
     yk(:,l)=grad(:)
  endif
  
end subroutine save_LBFGS
!*****************************************************!
!*          SEISCOPE OPTIMIZATION TOOLBOX            *!
!*****************************************************!
! This routines is used by the l-BFGS routine to      !
! compute the new pairs of models and gradient for    !
! the inverse Hessian approximation                   !
! Nocedal, 2nd edition, 2006 Algorithm 7.5 p. 179     !
!-----------------------------------------------------!
! INPUT : integer n dimension                         !
!         integer cpt_lbfgs counts the number of      ! 
!                           already stored pairs      !
!         integer l maximum number of stored pairs    !
!         real,dimension(n) x current point           !
!         real,dimension(n) x current gradient        !
! OUTPUT : sk,yk updated vectors                      !
!-----------------------------------------------------!
subroutine update_LBFGS(n,cpt_lbfgs,l,x,grad,sk,yk)

  implicit none

  !IN
  integer :: n,cpt_lbfgs,l
  real,dimension(n) :: x,grad
  !IN/OUT
  real,dimension(n,l) :: sk,yk
  
  if(cpt_lbfgs.le.l) then
     !---------------------------------------------------!
     ! if the number of stored pairs does not exceed the !
     ! maximum value, then compute a new pair sk yk and  !
     ! update the counter cpt_lbfgs                      !
     !---------------------------------------------------!
     sk(:,cpt_lbfgs)=x(:)-sk(:,cpt_lbfgs)
     yk(:,cpt_lbfgs)=grad(:)-yk(:,cpt_lbfgs)
     cpt_lbfgs=cpt_lbfgs+1
  else
     !---------------------------------------------------!
     ! otherwise, simply update the lth pair             !
     !---------------------------------------------------!
     sk(:,l)=x(:)-sk(:,l)
     yk(:,l)=grad(:)-yk(:,l)
  endif
  
end subroutine update_LBFGS

end module opt_LBFGS

!******************************************************************
!Copyright 2013-2016 SEISCOPE II project, All rights reserved.
!
!Redistribution and use in source and binary forms, with or
!without modification, are permitted provided that the following
!conditions are met:
!
!    *  Redistributions of source code must retain the above copyright
!       notice, this list of conditions and the following disclaimer.
!    *  Redistributions in binary form must reproduce the above
!       copyright notice, this list of conditions and the following
!       disclaimer in the documentation and/or other materials provided
!       with the distribution.
!    *  Neither the name of the SEISCOPE project nor the names of
!       its contributors may be used to endorse or promote products
!       derived from this software without specific prior written permission.
!
!Warranty Disclaimer:
!THIS SOFTWARE IS PROVIDED BY THE SEISCOPE PROJECT AND CONTRIBUTORS
!"AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
!LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
!FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
!SEISCOPE PROJECT OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
!INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
!BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
!LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
!CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT,
!STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING
!IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
!POSSIBILITY OF SUCH DAMAGE.

module opt_TRN
use, intrinsic :: iso_c_binding
use typedef
use miscellaneous
use opt_PSTD, only : xk, descent
use opt_PNLCG, only : descent_prev

private
real, allocatable, dimension(:) :: residual, eisenvect
public TRN, forcing_term_TRN, eisenvect

contains

subroutine trn_centry(n,x,fcost,grad,d,Hd,optim,flag,lb,ub) bind(c, name='TRN')
  !IN
  integer(c_int), value  :: n          !dimension of the problem
  real(c_float)   :: fcost             !cost associated with x
  real(c_float),dimension(n) :: grad   !gradient and preconditioned gradient at x 
  !IN/OUT  
  integer(c_int)  :: flag
  real(c_float),dimension(n) :: d   
  real(c_float),dimension(n) :: Hd   
  real(c_float),dimension(n) :: x      !current point
  type(optim_type) :: optim            !data structure 
  type(c_ptr), value  :: lb,ub
  real(c_float), pointer, dimension(:) :: lb_pass, ub_pass

  nullify(lb_pass)
  nullify(ub_pass)
  if (c_associated(ub)) call c_f_pointer(ub, ub_pass, (/n/))
  if (c_associated(lb)) call c_f_pointer(lb, lb_pass, (/n/))
  call trn(n,x,fcost,grad,d,Hd,optim,flag,lb_pass,ub_pass)
end subroutine trn_centry


!*****************************************************!
!*          SEISCOPE OPTIMIZATION TOOLBOX            *!
!*****************************************************!
! This file contains the routine for the computation  !
! of the Newton descent direction using a matrix-free ! 
! conjugate gradient solver.                          !
! The algorithm is taken from                         !
! Numerical Optimization, Nocedal, 2nd edition, 2006  !
! Algorithm 5.2 p.112                                 !
! The stopping criterion is taken from                !
! Choosing the forcing term in an Inexact Newton      !
! method, Eisenstat and Walker, 1994,                 !
! SIAM Journal on Scientific Computing 17 (1), 16-32  !
! The routine is implemented in a reverse             !
! communication format. The user is requested to give ! 
! Hessian-vector products at each iteration of the    !
! process through the communication flag              !
!------------------------------------------------------
! INPUT : integer n dimension                         !
!         real,dimension(n) grad current gradient     !
!         character*4 FLAG communication flag         !
! INPUT/OUTPUT : optim_type optim (data structure)    !
!-----------------------------------------------------!
subroutine descent_TRN(n,grad,d,Hd,optim,FLAG)
  
  implicit none
  
  !IN
  integer :: FLAG                            !communication FLAG
  integer :: n                               !dimension of the problem
  real,dimension(n) :: grad                  !gradient at the current point
  real,dimension(n) :: d   
  real,dimension(n) :: Hd
  !IN/OUT
  type(optim_type) :: optim                  !data structure
  !Local variables
  real :: dHd,norm_residual_prev,alpha,&
       beta,grad_term,descent_scal_Hd
  real,dimension(:),allocatable :: mgrad
    
  if(optim%CG_phase.eq. 0) then
     !-----------------------------------------------------!
     ! if CG_phase is INIT, initialize the conjugate !
     ! gradient process                                    !
     !-----------------------------------------------------!
     residual(:)=grad(:)
     d(:)=-1.*residual(:)
     Hd(:)=0.
     descent(:)=0.     
     optim%qk_CG=0.
     optim%hessian_term=0.     
     optim%norm_residual = norm2(residual)
     optim%conv_CG=0    
     optim%cpt_iter_CG=0
     call print_info_TRN(optim,0e0,FLAG)     
     optim%CG_phase=1
  else                         
     !-----------------------------------------------------!
     ! else perform one conjugate gradient iteration       !
     !-----------------------------------------------------!     
     dHd = dot_product(d,Hd) 
     if(dHd<0.) then 
        !-----------------------------------------------------!
        ! if dHd < 0, detection of a negative eigenvalue of   !
        ! the Hessian operator, stop the process              !        
        !-----------------------------------------------------!     
        optim%conv_CG=1
        write(21,*) 'Negative curvature'
        if(optim%cpt_iter_CG.eq.0) then                     
           !-----------------------------------------------------!
           ! if this is the first iteration, then return the     !
           ! opposite of the gradient as descent direction       !
           ! (steepest descent direction)                        !
           !-----------------------------------------------------!     
           descent(:)=d(:)            
           !-----------------------------------------------------!
           ! if the debug option is activated, compute the       !
           ! quadratic function minimized during the conjugate   !
           ! gradient process (check is this value decresae      !
           ! throughout the CG iterations )                      !
           !-----------------------------------------------------!     
           if(optim%debug == 1) then 
              allocate(mgrad(n))
              mgrad(:)=-1.*grad(:)              
              optim%norm_residual = norm2(residual)
              alpha=(optim%norm_residual**2)/dHd         
              optim%qkm1_CG=optim%qk_CG
              grad_term = dot_product(descent,mgrad)           
              optim%hessian_term=optim%hessian_term+(alpha**2)*dHd
              optim%qk_CG=-grad_term+0.5*optim%hessian_term  
              deallocate(mgrad)
           endif
        endif
     else 
        !-----------------------------------------------------!
        ! if dHd > 0, then perform one conjugate gradient     !
        ! iteration                                           !
        !-----------------------------------------------------!     
        !Update descent direction
        optim%norm_residual = norm2(residual)
        alpha=(optim%norm_residual**2)/dHd
        descent_prev(:)=descent(:)
        descent(:)=descent(:)+alpha*d(:)
        residual(:)=residual(:)+alpha*Hd(:)  
        !Update CG direction
        norm_residual_prev=optim%norm_residual
        optim%norm_residual = norm2(residual)
        beta=(optim%norm_residual**2)/(norm_residual_prev**2)
        d(:)=-1.*residual(:)+beta*d(:)                
        !Update iteration counter 
        optim%cpt_iter_CG=optim%cpt_iter_CG+1
        !-----------------------------------------------------!
        ! if the debug option is activated, compute the       !
        ! quadratic function minimized during the conjugate   !
        ! gradient process (check is this value decresae      !
        ! throughout the CG iterations )                      !
        !-----------------------------------------------------!        
        if(optim%debug == 1) then
           allocate(mgrad(n))
           mgrad(:)=-1.*grad(:)              
           optim%qkm1_CG=optim%qk_CG
           grad_term = dot_product(descent,mgrad)
           descent_scal_Hd = dot_product(descent_prev,Hd)
           optim%hessian_term=optim%hessian_term+(alpha**2)*dHd+&
                2.*alpha*descent_scal_Hd
           optim%qk_CG=-grad_term+0.5*optim%hessian_term
           deallocate(mgrad)
        endif
        !-----------------------------------------------------!
        ! Check if the Eisenstat stopping critertion is       !
        ! satisfied                                           !
        !-----------------------------------------------------!        
         if(&
            (optim%norm_residual.le.(optim%eta*optim%norm_grad)).or.&
            (optim%cpt_iter_CG.ge.optim%niter_max_CG)) then
            optim%conv_CG=1
         else
            optim%conv_CG=0
         endif       
        !-----------------------------------------------------!
        ! Print information on the current CG iteration       !
        !-----------------------------------------------------!
        call print_info_TRN(optim,0e0,FLAG)     
     endif
  endif
  
end subroutine descent_TRN

!*********************************************!
!*    SEISCOPE OPTIMIZATION TOOLBOX          *!
!*********************************************!
! This routine is used to deallocate all the  !
! arrays that have been used during the       !
! PSTD optimization                           !
!---------------------------------------------!
! INPUT/OUT:  optim_type optim                !
!---------------------------------------------!
subroutine finalize_TRN()
  
  implicit none   
  
  deallocate(xk)
  deallocate(descent)
  deallocate(descent_prev)
  deallocate(residual)
  deallocate(eisenvect) 
  
end subroutine finalize_TRN
!*****************************************************!
!*          SEISCOPE OPTIMIZATION TOOLBOX            *!
!*****************************************************!
! This file contains the routine for the computation  !
! of forcing term following the first formula of      !
! Eisenstat and Walker, see                           !
! Choosing the forcing term in an Inexact Newton      !
! method, Eisenstat and Walker, 1994,                 !
! SIAM Journal on Scientific Computing 17 (1), 16-32  !
!------------------------------------------------------
! INPUT : integer n dimension                         !
!         real,dimension(n) grad current gradient     !
!         character*4 FLAG communication flag         !
! INPUT/OUTPUT : optim_type optim (data structure)    !
!-----------------------------------------------------!
subroutine forcing_term_TRN(n,grad,residual,optim)
  
  implicit none
  !IN
  integer :: n                               !dimension of the problem
  real,dimension(n) :: grad                  !gradient at the current point
  real,dimension(n) :: residual
  !IN/OUT 
  type(optim_type) :: optim                  !data structure   
  !Local variable
  real :: eta_save,eta_save_power,norm_eisenvect
  
  !-----------------------------------------------------!
  ! Computation of the forcing term optim%eta following !
  ! the formula                                         !
  !-----------------------------------------------------!
  eta_save=optim%eta  
  eisenvect(:)=grad(:)-residual(:)
  norm_eisenvect = norm2 (eisenvect)
  optim%eta=norm_eisenvect/optim%norm_grad_m1
  
  !-----------------------------------------------------!
  ! Additional safeguard if optim%eta is too large      !       
  !-----------------------------------------------------!
  eta_save_power=eta_save**((1.+sqrt(5.))/2.)
  if(eta_save_power>0.1) then
     optim%eta=max(optim%eta,eta_save_power)
  endif
  if(optim%eta>1.) then
     optim%eta=0.9     
  endif
  
end subroutine forcing_term_TRN

!*****************************************************!
!*          SEISCOPE OPTIMIZATION TOOLBOX            *!
!*****************************************************!
! This file contains the routine for printing the     !
! convergence history in the files iterate_TRN.dat    !
! and iterate_TRN_CG.dat                              !
! The file iterate_TRN.dat is similar to the          !
! convergence history files of the other optimization !
! routines of the toolbox (PSTD,PNLCG,LBFGS,PLBFGS)   !
! The file iterate_TRN_CG.dat contains additional     !
! information on the convergence of the inner         !
! conjugate gradient iteration for the computation of !
! the inexact Newton descent direction.               !
!------------------------------------------------------
! INPUT : integer n dimension                         !
!         real,dimension(n) grad current gradient     !
!         character*4 FLAG communication flag         !
! INPUT/OUTPUT : optim_type optim (data structure)    !
!-----------------------------------------------------!
subroutine print_info_TRN(optim,fcost,FLAG)

  implicit none

  !IN
  integer  :: flag
  real :: fcost
  type(optim_type) :: optim !data structure   

  if(optim%print_flag.eq.1) then
     
     if(FLAG.eq.0) then 
        open(10,file='iterate_TRN.dat')     
        write(10,'(A90)') '******************************************************************************************'
        write(10,'(A70)') '                                 TRUNCATED NEWTON ALGORITHM                               '
        write(10,'(A90)') '******************************************************************************************'
        write(10,'(A30,ES10.2)') '     Convergence criterion  : ',optim%conv
        write(10,'(A30,I7)')     '     Niter_max              : ',optim%niter_max
        write(10,'(A30,ES10.2)') '     Initial cost is        : ',optim%f0
        write(10,'(A30,ES10.2)') '     Initial norm_grad is   : ',optim%norm_grad
        write(10,'(A30,I7)')     '     Maximum CG iter        : ',optim%niter_max_CG
        write(10,'(A90)') '******************************************************************************************'
        write(10,'(A10,A10,A10,A10,A12,A12,A8,A10,A9,A9)')&
             '   Niter   ' ,&
             '   fk      ' ,&
             '   ||gk||  ' ,&
             '     fk/f0   ' ,&
             '       alpha   ' ,&
             '        nls     ',&
             '  nit_CG',&
             '    eta     ',&
             '  ngrad ',&
             '  nhess '
        write(10,'(I6,ES12.2,ES12.2,ES12.2,ES12.2,I8,I8,ES12.2,I8,I8)') &
             optim%cpt_iter,&
             fcost,&
             optim%norm_grad,&
             fcost/optim%f0,&
             optim%alpha,&
             optim%cpt_ls,&
             optim%cpt_iter_CG,&
             optim%eta,&
             optim%nfwd_pb,&
             optim%nhess
        open(21,file='iterate_TRN_CG.dat')     
        write(21,'(A90)') '******************************************************************************************'
        write(21,'(A70)') '                                 TRUNCATED NEWTON ALGORITHM                               '
        write(21,'(A70)') '                                      INNER CG HISTORY                                    '
        write(21,'(A90)') '******************************************************************************************'
        write(21,'(A30,ES10.2)') '     Convergence criterion  : ',optim%conv
        write(21,'(A30,I7)')     '     Niter_max              : ',optim%niter_max
        write(21,'(A30,ES10.2)') '     Initial cost is        : ',optim%f0
        write(21,'(A30,ES10.2)') '     Initial norm_grad is   : ',optim%norm_grad
        write(21,'(A30,I7)')     '     Maximum CG iter        : ',optim%niter_max_CG
        write(21,'(A90)') '******************************************************************************************'
     elseif(FLAG.eq.2) then     
        write(10,'(A70)') '**********************************************************************'
        if(optim%cpt_iter.eq.optim%niter_max) then
           write(10,'(A50)') '  STOP: MAXIMUM NUMBER OF ITERATION REACHED    '
        else
           write(10,'(A50)') '  STOP: CONVERGENCE CRITERION SATISFIED        '
        endif
        write(10,'(A70)') '**********************************************************************'
        close(10)
     elseif(FLAG.eq.4) then
        write(10,'(A70)') '**********************************************************************'
        write(10,'(A50)') '  STOP: LINESEARCH FAILURE    '
        write(10,'(A70)') '**********************************************************************'
        close(10)     
     elseif(optim%comm.eq.0) then
        if(optim%CG_phase.eq. 0) then
           write(21,'(A90)') '-------------------------------------------------------------------------------------------------'
           write(21,'(A20,I4,A10,ES12.2)') ' NONLINEAR ITERATION ',optim%cpt_iter, ' ETA IS : ',optim%eta
           write(21,'(A90)') '-------------------------------------------------------------------------------------------------'
           write(21,'(A12,A10,A10,A20)')&
                '  Iter_CG      ',&
                '  qk           ',&
                ' norm_res     ',&
                ' norm_res/||gk||  '
           write(21,'(I8,ES12.2,ES12.2,ES12.2)') &
                optim%cpt_iter_CG,&
                optim%qk_CG,&
                optim%norm_residual,&
                optim%norm_residual/optim%norm_grad       
        else
           write(21,'(I8,ES12.2,ES12.2,ES12.2)') &
                optim%cpt_iter_CG,&
                optim%qk_CG,&
                optim%norm_residual,&
                optim%norm_residual/optim%norm_grad
        endif
     else
        write(10,'(I6,ES12.2,ES12.2,ES12.2,ES12.2,I8,I8,ES12.2,I8,I8)') &
             optim%cpt_iter,&          
             fcost,&
             optim%norm_grad,&
             fcost/optim%f0,&
             optim%alpha,&
             optim%cpt_ls,&
             optim%cpt_iter_CG,&
             optim%eta,&
             optim%nfwd_pb,&
             optim%nhess
     endif
  endif
end subroutine print_info_TRN

!*****************************************************!
!*          SEISCOPE OPTIMIZATION TOOLBOX            *!
!*****************************************************!
! This routine is the reverse communication mode      !
! truncated Newton. This algorithm is described in    !
! L.Metivier, R. Brossier, J. Virieux, S.Operto,      !
! Truncated Newton and full waveform inversion, 2013  !
! SIAM Journal on Scientific Computing, Vol. 35,      !
! No. 2, pp. B401–B437,                               !         
!                                                     !
! This routine performs an iterative                  !
! minimization of a function f following the          !
! recurrence                                          !
!                                                     !
! x_{0}=x0                                            !
! x_{k+1}=x_k+\alpha_k d_k  (1)                       !
!                                                     !
! where the descent direction d_k is computed through !
! the resolution of the linear system                 !
!                                                     !
! H_k d_k=- \nabla f_k  (2)                           !
!                                                     !
! with H_k        : Hessian operator at iteration k   !
!                                                     !
!\nabla f_k       : gradient of f in x_k              !
!                                                     !
! and alpha_k is the steplength computed through the  !
! common linesearch algorithm of the TOOLBOX          !
!                                                     !
! The linear system (2) is solved through a matrix    !
! free conjugate gradient algorithm which requires the!
! user to perform multiplication of given vector by   !
! the Hessian operator.                               !                     
!                                                     !
! Because of these tow nested algorithms, the reverse !
! communication strategy requires additional          !
! communicators within the code to clearly track which!
! stage the optimizer has reached                     !
!                                                     !
! The first call to the algorithm must be done with   !
! FLAG='INIT'. For this first call, the initial point !
! x0 is given through the variable x, and the input   !
! variable fcost and grad must correspond respectively!
! to the misfit and gradient at x0.                   !
!                                                     !
! The reverse communication with the user is          !
! performed through the variable FLAG. This           !
! variable indicates to the user on return what action! 
! he has to do, or the state of the algorithm.        !
! Possible values are                                 !
! - FLAG='GRAD' => the user must compute the cost and !
!                  gradient at current point x in     !
!                  fcost and grad                     !
! - FLAG='HESS' => the user must multiply the vector  !
!                  optim%d by the Hessian operator and!
!                  set the result in optim%Hd         !
! - FLAG='CONV' => a minimizer has been found         !
! - FLAG='NSTE' => a new step is performed            !
! - FLAG='FAIL' => the linesearch has failed          !
!-----------------------------------------------------!
! INPUT  : integer :: n (dimension)                   ! 
!          real fcost (current cost)                  !
!          real,dimension(n) grad                     !
! INPUT/OUTPUT : real,dimension(n) x                  !
!                optim_typ optim (data structure)     !
!                character*4 FLAG (communication)     !
!-----------------------------------------------------!
subroutine TRN(n,x,fcost,grad,d,Hd,optim,FLAG,lb,ub)
  
  implicit none
  
  !IN
  integer  :: n                               !dimension of the problem
  real :: fcost                               !cost associated with x
  real,dimension(n) :: grad                   !gradient at x 
  !IN/OUT  
  integer  :: flag
  real,dimension(n) :: x                      !current point
  real,dimension(n) :: d   
  real,dimension(n) :: Hd
  type(optim_type) :: optim                   !data structure  
  real(c_float),optional, dimension(n) :: lb,ub 
  !Local variable
  logical :: test_conv
  

  if(FLAG.eq. 0) then
     !-----------------------------------------------------!
     ! if FLAG is INIT, call the dedicated initialization  !
     ! subroutine to allocate data structure optim         !
     !-----------------------------------------------------!
     !call init_TRN(n,x,fcost,grad,optim)    
     allocate(xk(n), descent(n), descent_prev(n))
     allocate(residual(n), eisenvect(n))
     xk(:)=x(:)
     optim%norm_grad = norm2 (grad) ! norm of the first gradient
     call print_info_TRN(optim,fcost,FLAG)     
     optim%comm=0     
     optim%CG_phase=0
     optim%nfwd_pb=optim%nfwd_pb+1
     optim%conv_CG=0
     FLAG=6
  endif
  if(optim%comm.eq.0) then 
     !-----------------------------------------------------!
     ! if Comm is DES, the optimizer is computing    !
     ! a descent direction through the conjugate gradient  !
     !-----------------------------------------------------!
     call descent_TRN(n,grad,d,Hd,optim, FLAG) 
     if(optim%conv_CG == 1) then        
         !-----------------------------------------------------!
        ! if the conjugate gradient has converged go to next  !
        ! phase: linesearch in the descent direction          !
        !-----------------------------------------------------!  
        optim%comm=1
        optim%CG_phase=0        
        FLAG=6        
     else
        !-----------------------------------------------------!
        ! else perform a new iteration of conjugate gradient  ! 
        ! and ask the user to compute a Hessian-vector product!
        !-----------------------------------------------------!  
        FLAG=7
        optim%nhess=optim%nhess+1
     endif
  elseif(optim%comm.eq. 1) then 
     !-----------------------------------------------------!
     ! if Comm is NSTE, the optimizer is looking for !
     ! a new step in the descent direction                 !
     !-----------------------------------------------------!
     call std_linesearch(n,x,fcost,grad,xk,descent,optim,lb,ub)     
     if(optim%task.eq. 0) then !NEW STEP            
        !-----------------------------------------------------!
        ! if optim%task is 'NEW_STEP, the linesearch process  !
        ! has found the new step                              !
        !-----------------------------------------------------!
        optim%cpt_iter=optim%cpt_iter+1
        !Save the previous gradient norm 
        optim%norm_grad_m1=optim%norm_grad
        !Compute the new gradient norm 
        optim%norm_grad = norm2(grad)        
        !Print info on current nonlinear iteration
        call print_info_TRN(optim,fcost,FLAG)        
        !Test for convergence
        call std_test_conv(optim,fcost,test_conv)
        if(test_conv) then
           FLAG=2          
           call print_info_TRN(optim,fcost,FLAG)        
           close(10)
           close(21)           
           call finalize_TRN()
        else
           !Flags for the computation of the new descent direction
           FLAG=3           
           optim%comm=0       
           !Update forcing term optim%eta following the Eisenstat and Walker formula
           call forcing_term_TRN(n,grad,residual,optim)        
        endif
     elseif(optim%task.eq. 1) then !STILL SEARCHING THE STEP 
        !-----------------------------------------------------!
        ! if optim%task is 'NEW_GRAD, the linesearch process  !
        ! is continuing, the gradient at the current point is !
        ! required                                            ! 
        !-----------------------------------------------------!
        FLAG=1        
        optim%nfwd_pb=optim%nfwd_pb+1
     elseif(optim%task.eq. 2) then        
        !-----------------------------------------------------!
        ! if optim%task is 'FAILURE, the linesearch process   !
        ! has failed, the iterations are stopped              !
        !-----------------------------------------------------!
        FLAG=4
        call print_info_TRN(optim,fcost,FLAG)
        close(10)
        close(21)
        call finalize_TRN()
     endif
  endif
  
end subroutine TRN

end module opt_TRN

!******************************************************************
!Copyright 2013-2016 SEISCOPE II project, All rights reserved.
!
!Redistribution and use in source and binary forms, with or
!without modification, are permitted provided that the following
!conditions are met:
!
!    *  Redistributions of source code must retain the above copyright
!       notice, this list of conditions and the following disclaimer.
!    *  Redistributions in binary form must reproduce the above
!       copyright notice, this list of conditions and the following
!       disclaimer in the documentation and/or other materials provided
!       with the distribution.
!    *  Neither the name of the SEISCOPE project nor the names of
!       its contributors may be used to endorse or promote products
!       derived from this software without specific prior written permission.
!
!Warranty Disclaimer:
!THIS SOFTWARE IS PROVIDED BY THE SEISCOPE PROJECT AND CONTRIBUTORS
!"AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
!LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
!FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
!SEISCOPE PROJECT OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
!INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
!BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
!LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
!CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT,
!STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING
!IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
!POSSIBILITY OF SUCH DAMAGE.

module opt_PNLCG
use, intrinsic :: iso_c_binding
use typedef
use miscellaneous
use opt_PSTD, only : xk, descent

private
real, allocatable, dimension(:) :: grad_prev, descent_prev
public PNLCG, grad_prev, descent_prev

!Module procedures have access to module variables through host association.

contains

subroutine pnlcg_centry(n,x,fcost,grad,grad_preco,optim,flag,lb,ub) bind(c, name='PNLCG')
  !IN
  integer(c_int), value  :: n                   !dimension of the problem
  real(c_float)   :: fcost                      !cost associated with x
  real(c_float),dimension(n) :: grad,grad_preco !gradient and preconditioned gradient at x 
  !IN/OUT  
  integer(c_int)  :: flag
  real(c_float),dimension(n) :: x               !current point
  type(optim_type) :: optim                     !data structure 
  type(c_ptr), value  :: lb,ub
  real(c_float), pointer, dimension(:) :: lb_pass, ub_pass

  nullify(lb_pass)
  nullify(ub_pass)
  if (c_associated(ub)) call c_f_pointer(ub, ub_pass, (/n/))
  if (c_associated(lb)) call c_f_pointer(lb, lb_pass, (/n/))
  call pnlcg(n,x,fcost,grad,grad_preco,optim,flag,lb_pass,ub_pass)
end subroutine pnlcg_centry

!*****************************************************!
!*          SEISCOPE OPTIMIZATION TOOLBOX            *!
!*****************************************************!
! Computation of the descent direction given by the 
! preconditioned nonlinear conjugate gradient algorithm 
! of Dai and Yuan 
! Y. DAI AND Y. YUAN, A nonlinear conjugate gradient  !
! method with a strong global convergence property,   !
! SIAM Journal on Optimization, 10 (1999), pp. 177–182!
!                                                     !
! See also Nocedal, Numerical optimization,           !
! 2nd edition p.132                                   !
!-----------------------------------------------------!
! INPUT  : integer :: n (dimension)                   ! 
!          real,dimension(n) :: grad,grad_preco       !
! INPUT/OUTPUT : optim_typ optim (data structure)     !
!-----------------------------------------------------!
subroutine descent_PNLCG(n,grad,grad_preco)
  
  implicit none
  !IN
  integer :: n
  real,dimension(n) :: grad,grad_preco   
  !Local variables
  real :: gkpgk,skpk,beta
  real,dimension(:),allocatable :: sk
  
  !------------------------------------------------------------!
  ! Storing old descent direction                              !
  !------------------------------------------------------------!
  descent_prev(:)=descent(:)
  
  !------------------------------------------------------------!
  ! Computation of beta                                        !
  !------------------------------------------------------------!  ! 
  gkpgk =dot_product(grad,grad_preco)  
  allocate(sk(n))
  sk(:)=grad(:)-grad_prev(:)
  skpk = dot_product(sk,descent_prev)
  beta=gkpgk/skpk
  
  !------------------------------------------------------------!
  ! Safeguard (may be useful in some cases)                    !
  !------------------------------------------------------------! 
  if((beta.ge.1e5).or.(beta.le.-1e5)) then     
     beta=0.
  endif
  
  !------------------------------------------------------------!
  ! Computation of the descent direction                       !
  !------------------------------------------------------------! 
  descent(:)=-1.*grad_preco(:)+beta*descent_prev(:)
  
  !------------------------------------------------------------!
  ! Deallocation                                               ! 
  !------------------------------------------------------------!
  deallocate(sk)

end subroutine descent_PNLCG
!*********************************************!
!*    SEISCOPE OPTIMIZATION TOOLBOX          *!
!*********************************************!
! This routine is used to deallocate all the  !
! arrays that have been used during the       !
! PSTD optimization                           !
!---------------------------------------------!
! INPUT/OUT:  optim_type optim                !
!---------------------------------------------!
subroutine finalize_PNLCG
  
  implicit none
  
  deallocate(xk)
  deallocate(grad_prev)
  deallocate(descent)
  deallocate(descent_prev)
  
end subroutine finalize_PNLCG

!*****************************************************!
!*          SEISCOPE OPTIMIZATION TOOLBOX            *!
!*****************************************************!
! This routine is the reverse communication mode      !
! preconditioned nonlinear conjugate gradient         !
! algorithm of Dai and Yuan                           !
! Y. DAI AND Y. YUAN, A nonlinear conjugate gradient  !
! method with a strong global convergence property,   !
! SIAM Journal on Optimization, 10 (1999), pp. 177–182!
!                                                     !
! See also Nocedal, Numerical optimization,           !
! 2nd edition p.132                                   !
!                                                     !
! This routine performs an iterative                  !
! minimization of a function f following the          !
! recurrence                                          !
!                                                     !
! x_{0}=x0                                            !
! x_{k+1}=x_k+\alpha_k d_k                            !
!                                                     !
! where the descent direction d_k is                  !
!                                                     !
! d_k=-Q_k \nabla f_k + \beta_k d_{k-1}               !
!                                                     !
! where Q_k       : preconditioner at iteration k     !
!      \nabla f_k : gradient of f in x_k              !
!      \beta_k    : scalar computed through the       !
!                   Dai and Yuan formula              !
!                                                     !
! and alpha_k is the steplength computed through the  !
! common linesearch algorithm of the TOOLBOX          !
!                                                     !
! The first call to the algorithm must be done with   !
! FLAG='INIT'. For this first call, the initial point !
! x0 is given through the variable x. The input       !
! variables fcost and grad, grad_preco must correspond!
! respectively to the misfit, gradient and            ! 
! preconditioned gradient at x0.                      !
!                                                     !
! The reverse communication with the user is          !
! performed through the variable FLAG. This           !
! variable indicates to the user on return what action! 
! he has to do, or the state of the algorithm.        !
! Possible values are                                 !
! - FLAG='GRAD' => the user must compute the cost,    !
!                  gradient and preconditioned        !
!                  gradient at current point x        ! 
! - FLAG='CONV' => a minimizer has been found         !
! - FLAG='NSTE' => a new step is performed            !
! - FLAG='FAIL' => the linesearch has failed          !
!-----------------------------------------------------!
! INPUT  : integer :: n (dimension)                   ! 
!          real fcost (current cost)                  !
!          real,dimension(n) grad                     !
!          real,dimension(n) grad_preco               !
! INPUT/OUTPUT : real,dimension(n) x                  !
!                optim_typ optim (data structure)     !
!                character*4 FLAG (communication)     !
!-----------------------------------------------------!
subroutine PNLCG(n,x,fcost,grad,grad_preco,optim,flag,lb,ub)

  implicit none
  
  !IN
  integer  :: n                           !dimension of the problem
  real   :: fcost                       !cost associated with x
  real,dimension(n) :: grad,grad_preco !gradient and preconditioned gradient at x 
  !IN/OUT  
  integer  :: flag
  real,dimension(n) :: x               !current point
  real(c_float),optional, dimension(n) :: lb,ub
  type(optim_type) :: optim            !data structure   
  !Local variable
  logical :: test_conv
  
  if(FLAG.eq. 0) then
     !-----------------------------------------------------!
     ! if FLAG is INIT, call the dedicated initialization  !
     ! subroutine to allocate data structure optim and     !
     ! initialize the linesearch process                   !
     !-----------------------------------------------------!
     allocate(grad_prev(n), descent_prev(n), xk(n), descent(n))
     xk(:)=x(:)
     descent(:)=-1.*grad_preco(:)  ! first descent direction 
     call std_linesearch(n,x,fcost,grad,xk,descent,optim,lb,ub) !lb,ub,optim
     call print_info(n,'CG',optim,fcost,grad,FLAG)
     FLAG=1     
     optim%nfwd_pb=optim%nfwd_pb+1
     !Store current gradient before the user compute the new one
     grad_prev(:)=grad(:)      
  else
     !-----------------------------------------------------!
     ! else call the linesearch process                    !  
     !-----------------------------------------------------!
     call std_linesearch(n,x,fcost,grad,xk,descent,optim,lb,ub) !lb,ub,optim    
     if(optim%task.eq. 0) then 
        optim%cpt_iter=optim%cpt_iter+1
        !-----------------------------------------------------!
        ! test for convergence                                !
        !-----------------------------------------------------!
        call std_test_conv(optim,fcost,test_conv)
        if(test_conv) then
           FLAG=2
           !print info on current iteration        
           call print_info(n,'CG',optim,fcost,grad,FLAG)
           call finalize_PNLCG
        else
           FLAG=3
           !-----------------------------------------------------!
           ! if a NEW_STEP is taken, compute a new descent       !
           ! direction using current descent, gradient and       !
           ! preconditioned gradient                             !
           !-----------------------------------------------------!
           call descent_PNLCG(n,grad,grad_preco)                    
           !print info on current iteration        
           call print_info(n,'CG',optim,fcost,grad,FLAG)
        endif
     elseif(optim%task.eq. 1) then
        !-----------------------------------------------------!
        ! if the linesearch needs a new gradient then ask the !  
        ! user to provide it
        !-----------------------------------------------------!
        FLAG=1         
        optim%nfwd_pb=optim%nfwd_pb+1
        !Store current gradient before the user compute the new one
        grad_prev(:)=grad(:)        
     elseif(optim%task.eq. 2) then        
        !-----------------------------------------------------!
        ! if the linesearch has failed, inform the user       !
        !-----------------------------------------------------!
        FLAG=4
        !print info on current iteration
        call print_info(n,'CG',optim,fcost,grad,FLAG)
        call finalize_PNLCG
     endif
  endif
  
end subroutine PNLCG

end module opt_PNLCG

!******************************************************************
!Copyright 2013-2016 SEISCOPE II project, All rights reserved.
!
!Redistribution and use in source and binary forms, with or
!without modification, are permitted provided that the following
!conditions are met:
!
!    *  Redistributions of source code must retain the above copyright
!       notice, this list of conditions and the following disclaimer.
!    *  Redistributions in binary form must reproduce the above
!       copyright notice, this list of conditions and the following
!       disclaimer in the documentation and/or other materials provided
!       with the distribution.
!    *  Neither the name of the SEISCOPE project nor the names of
!       its contributors may be used to endorse or promote products
!       derived from this software without specific prior written permission.
!
!Warranty Disclaimer:
!THIS SOFTWARE IS PROVIDED BY THE SEISCOPE PROJECT AND CONTRIBUTORS
!"AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
!LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
!FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
!SEISCOPE PROJECT OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
!INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
!BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
!LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
!CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT,
!STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING
!IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
!POSSIBILITY OF SUCH DAMAGE.

module opt_PTRN
use, intrinsic :: iso_c_binding
use typedef
use miscellaneous
use opt_PSTD, only : xk, descent
use opt_PNLCG, only : descent_prev
use opt_TRN, only : forcing_term_TRN, eisenvect

private
public PTRN

contains

subroutine ptrn_centry(n,x,fcost,grad,grad_preco,residual,residual_preco, &
                       d,Hd,optim,flag,lb,ub) bind(c, name='PTRN')
  !IN
  integer(c_int), value  :: n          !dimension of the problem
  real(c_float)   :: fcost             !cost associated with x
  real(c_float),dimension(n) :: grad, grad_preco   !gradient and preconditioned gradient at x 
  real(c_float),dimension(n) :: residual, residual_preco  
  real(c_float),dimension(n) :: d, Hd 
  !IN/OUT  
  integer(c_int)  :: flag
  real(c_float),dimension(n) :: x      !current point
  type(optim_type) :: optim            !data structure 
  type(c_ptr), value  :: lb,ub
  real(c_float), pointer, dimension(:) :: lb_pass, ub_pass

  nullify(lb_pass)
  nullify(ub_pass)
  if (c_associated(ub)) call c_f_pointer(ub, ub_pass, (/n/))
  if (c_associated(lb)) call c_f_pointer(lb, lb_pass, (/n/))
  call ptrn(n,x,fcost,grad,grad_preco,residual,residual_preco, &
            d,Hd,optim,flag,lb_pass,ub_pass)
end subroutine ptrn_centry

!*****************************************************!
!*          SEISCOPE OPTIMIZATION TOOLBOX            *!
!*****************************************************!
! This file contains the routines for the computation !
! of the Newton descent direction using a             !
! preconditioned matrix-free conjugate gradient solver!
! The algorithm is taken from                         !
! Numerical Optimization, Nocedal, 2nd edition, 2006  !
! Algorithm 5.3 p.119                                 !
! The stopping criterion is taken from                !
! Choosing the forcing term in an Inexact Newton      !
! method, Eisenstat and Walker, 1994,                 !
! SIAM Journal on Scientific Computing 17 (1), 16-32  !
! The routine is implemented in a reverse             !
! communication format. The user is requested         !
! - to compute  Hessian-vector products at each       !
!   iteration of the process                          !
! - to apply its preconditioner to the residuals      !
!   at each iteration of the process                  !
! Because of the preconditioning, the routine has been!
! split into three routines, compared to the TRN      !
! version                                             !
! The first routine is descent_PTRN0 for              !
! initialization                                      !   
! The second routine is descent_PTRN1 for the first   !
! part of the conjugate gradient iteration, before    !
! preconditioning.                                    !
! The third routine is descent_PTRN2 for the second   !
! part of the conjugate gradient iteration, after     !
! preconditioning.                                    !

!-----------------------------------------------------!
! descent_PTRN0
!-----------------------------------------------------!
! INPUT : integer n dimension                         !
!         real,dimension(n) grad current gradient     !
!         real,dimension(n) grad_preco preconditioned !
!                           current gradient          !
!         character*4 FLAG communication flag         !
! INPUT/OUTPUT : optim_type optim (data structure)    !
!-----------------------------------------------------!
subroutine descent_PTRN0(n,grad,grad_preco,residual, residual_preco,d,Hd,optim,FLAG)
  
  implicit none
  
  !IN
  integer :: FLAG                                          !communication FLAG
  integer :: n                                             !dimension of the problem
  real,dimension(n) :: grad                                !gradient at current point
  real,dimension(n) :: grad_preco                          !preconditioned gradient at current point
  real,dimension(n) :: d, Hd 
  real,dimension(n) :: residual, residual_preco  
  !IN/OUT
  type(optim_type) :: optim
  
  !-----------------------------------------------------!
  ! Initialization of the conjugate gradient process    !
  !-----------------------------------------------------!
  residual(:)=grad(:)
  residual_preco(:)=grad_preco(:)
  d(:)=-1.*residual_preco(:)
  Hd(:)=0.
  descent(:)=0.     
  optim%qk_CG=0.
  optim%hessian_term=0.     
  optim%norm_residual = norm2(residual)
  optim%conv_CG=0    
  optim%cpt_iter_CG=0
  call print_info_PTRN(optim,0e0,FLAG)     

end subroutine descent_PTRN0

!-----------------------------------------------------!
! descent_PTRN1
!-----------------------------------------------------!
! INPUT : integer n dimension                         !
!         real,dimension(n) grad current gradient     !
!         character*4 FLAG communication flag         !
! INPUT/OUTPUT : optim_type optim (data structure)    !
!-----------------------------------------------------!
subroutine descent_PTRN1(n,grad,residual,residual_preco,d,Hd,optim)
  
  implicit none
  
  !IN
  integer :: n                               !dimension of the problem
  real,dimension(n) :: grad                  !gradient at current point
  real,dimension(n) :: d, Hd 
  real,dimension(n) :: residual, residual_preco  
  !IN/OUT
  type(optim_type) :: optim                  !data structure
  !Local variables
  real :: grad_term
  real,dimension(:),allocatable :: mgrad
  
  !-----------------------------------------------------!
  ! start one conjugate gradient iteration       !
  !-----------------------------------------------------!    
  optim%dHd = dot_product(d,Hd)        
  if(optim%dHd<0.) then
     !-----------------------------------------------------!
     ! if optim%dHd < 0, detection of a negative eigenvalue of   !
     ! the Hessian operator, stop the process              !        
     !-----------------------------------------------------!  
     optim%conv_CG=1
     write(21,*) 'Negative curvature'
     if(optim%cpt_iter_CG.eq.0) then
        !-----------------------------------------------------!
        ! if this is the first iteration, thenreturn the      !
        ! opposite of the preconditioned gradient as descent  !
        ! direction: preconditioned steepest descent direction!
        !-----------------------------------------------------!   
        descent(:)=d(:) 
        !-----------------------------------------------------!
        ! if the debug option is activated, compute the       !
        ! quadratic function minimized during the conjugate   !
        ! gradient process (check is this value decresae      !
        ! throughout the CG iterations )                      !
        !-----------------------------------------------------!
        if(optim%debug == 1) then
           optim%res_scal_respreco = dot_product(residual,residual_preco)
           optim%alpha_CG=optim%res_scal_respreco/optim%dHd         
           optim%qkm1_CG=optim%qk_CG
           allocate(mgrad(n))
           mgrad(:)=-1.*grad(:)           
           grad_term = dot_product(descent,mgrad)           
           optim%hessian_term=optim%hessian_term+(optim%alpha_CG**2)*optim%dHd
           optim%qk_CG=-grad_term+0.5*optim%hessian_term  
           deallocate(mgrad)
        endif
     endif
  else         
     !-----------------------------------------------------!
     ! if optim%dHd > 0, then start one conjugate gradient       !
     ! iteration                                           !
     !-----------------------------------------------------!   
     !Update descent direction
     optim%res_scal_respreco = dot_product(residual,residual_preco)
     optim%alpha_CG=optim%res_scal_respreco/optim%dHd
     descent_prev(:)=descent(:)
     descent(:)=descent(:)+optim%alpha_CG*d(:)
     residual(:)=residual(:)+optim%alpha_CG*Hd(:)        
     !STOP HERE and wait for preconditioning
  end if
  
end subroutine descent_PTRN1

!-----------------------------------------------------!
! descent_PTRN2
!-----------------------------------------------------!
! INPUT : integer n dimension                         !
!         real,dimension(n) grad current gradient     !
!         character*4 FLAG communication flag         !
! INPUT/OUTPUT : optim_type optim (data structure)    !
!-----------------------------------------------------!
subroutine descent_PTRN2(n,grad,residual,residual_preco,d,Hd,optim,FLAG)
  
  implicit none
  
  !IN
  integer :: FLAG                                     !communication FLAG
  integer :: n                                        !dimension of the problem
  real,dimension(n) :: grad                           !gradient at current point
  real,dimension(n) :: d, Hd 
  real,dimension(n) :: residual, residual_preco  
  !IN/OUT
  type(optim_type) :: optim                           !data structure
  !Local variables
  real :: res_scal_respreco_prev,&
       beta,grad_term,descent_scal_Hd
  real,dimension(:),allocatable :: mgrad
  
  !-----------------------------------------------------!
  ! continue the current conjugate gradient iteration   !
  !-----------------------------------------------------! 
  !Update CG direction
  res_scal_respreco_prev=optim%res_scal_respreco
  optim%res_scal_respreco = dot_product(residual,residual_preco)
  beta=(optim%res_scal_respreco)/(res_scal_respreco_prev)
  d(:)=-1.*residual_preco(:)+beta*d(:)                  
  !Update iteration counter 
  optim%cpt_iter_CG=optim%cpt_iter_CG+1  
  !-----------------------------------------------------!
  ! if the debug option is activated, compute the       !
  ! quadratic function minimized during the conjugate   !
  ! gradient process (check is this value decresae      !
  ! throughout the CG iterations )                      !
  !-----------------------------------------------------!  
  if(optim%debug == 1) then
     optim%qkm1_CG=optim%qk_CG
     allocate(mgrad(n))
     mgrad(:)=-1.*grad(:)
     grad_term = dot_product(descent,mgrad)
     descent_scal_Hd= dot_product(descent_prev,Hd)
     optim%hessian_term=optim%hessian_term+(optim%alpha_CG**2)*optim%dHd+&
          2.*optim%alpha_CG*descent_scal_Hd
     optim%qk_CG=-grad_term+0.5*optim%hessian_term
     deallocate(mgrad)
  endif
  !-----------------------------------------------------!
  ! Check if the Eisenstat stopping critertion is       !
  ! satisfied                                           !
  !-----------------------------------------------------! 
  optim%norm_residual = norm2(residual)
  if (&
      (optim%norm_residual.le.(optim%eta*optim%norm_grad)).or.&
      (optim%cpt_iter_CG.ge.optim%niter_max_CG)) then
    optim%conv_CG=1
  else
    optim%conv_CG=0
  endif       
  !-----------------------------------------------------!
  ! Print information on the current CG iteration       !
  !-----------------------------------------------------!
  call print_info_PTRN(optim,0e0,FLAG)     
  
end subroutine descent_PTRN2

!*********************************************!
!*    SEISCOPE OPTIMIZATION TOOLBOX          *!
!*********************************************!
! This routine is used to deallocate all the  !
! arrays that have been used during the       !
! PSTD optimization                           !
!---------------------------------------------!
! INPUT/OUT:  optim_type optim                !
!---------------------------------------------!
subroutine finalize_PTRN()
  
  implicit none   
  
  deallocate(xk)
  deallocate(descent)
  deallocate(descent_prev)
  deallocate(eisenvect)
  
end subroutine finalize_PTRN

!*****************************************************!
!*          SEISCOPE OPTIMIZATION TOOLBOX            *!
!*****************************************************!
! This file contains the routine for printing the     !
! convergence history in the files iterate_PTRN.dat   !
! and iterate_PTRN_CG.dat                             !
! The file iterate_PTRN.dat is similar to the         !
! convergence history files of the other optimization !
! routines of the toolbox (PSTD,PNLCG,LBFGS,PLBFGS)   !
! The file iterate_PTRN_CG.dat contains additional    !
! information on the convergence of the inner         !
! preconditioned conjugate gradient iteration for the !
! computation of the inexact Newton descent direction.!
!------------------------------------------------------
! INPUT : integer n dimension                         !
!         real,dimension(n) grad current gradient     !
!         character*4 FLAG communication flag         !
! INPUT/OUTPUT : optim_type optim (data structure)    !
!-----------------------------------------------------!
subroutine print_info_PTRN(optim,fcost,FLAG)

  implicit none

  !IN
  integer :: FLAG
  real :: fcost
  type(optim_type) :: optim !data structure   

  if(optim%print_flag.eq.1) then

     if(FLAG.eq. 0) then          
        open(10,file='iterate_PTRN.dat')     
        write(10,'(A90)') '******************************************************************************************'
        write(10,'(A70)') '                      PRECONDITIONED TRUNCATED NEWTON ALGORITHM                           '
        write(10,'(A90)') '******************************************************************************************'
        write(10,'(A30,ES10.2)') '     Convergence criterion  : ',optim%conv
        write(10,'(A30,I7)')     '     Niter_max              : ',optim%niter_max
        write(10,'(A30,ES10.2)') '     Initial cost is        : ',optim%f0
        write(10,'(A30,ES10.2)') '     Initial norm_grad is   : ',optim%norm_grad
        write(10,'(A30,I7)')     '     Maximum CG iter        : ',optim%niter_max_CG
        write(10,'(A90)') '******************************************************************************************'
        write(10,'(A10,A10,A10,A10,A12,A12,A8,A10,A9,A9)')&
             '   Niter   ' ,&
             '   fk      ' ,&
             '   ||gk||  ' ,&
             '     fk/f0   ' ,&
             '       alpha   ' ,&
             '        nls     ',&
             '  nit_CG',&
             '    eta     ',&
             '  ngrad ',&
             '  nhess '
        write(10,'(I6,ES12.2,ES12.2,ES12.2,ES12.2,I8,I8,ES12.2,I8,I8)') &
             optim%cpt_iter,&
             fcost,&
             optim%norm_grad,&
             fcost/optim%f0,&
             optim%alpha,&
             optim%cpt_ls,&
             optim%cpt_iter_CG,&
             optim%eta,&
             optim%nfwd_pb,&
             optim%nhess
        open(21,file='iterate_PTRN_CG.dat')     
        write(21,'(A90)') '******************************************************************************************'
        write(21,'(A70)') '                        PRECONDITIONED TRUNCATED NEWTON ALGORITHM                         '
        write(21,'(A70)') '                                      INNER CG HISTORY                                    '
        write(21,'(A90)') '******************************************************************************************'
        write(21,'(A30,ES10.2)') '     Convergence criterion  : ',optim%conv
        write(21,'(A30,I7)')     '     Niter_max              : ',optim%niter_max
        write(21,'(A30,ES10.2)') '     Initial cost is        : ',optim%f0
        write(21,'(A30,ES10.2)') '     Initial norm_grad is   : ',optim%norm_grad
        write(21,'(A30,I7)')     '     Maximum CG iter        : ',optim%niter_max_CG
        write(21,'(A90)') '******************************************************************************************'
     elseif(FLAG.eq.2) then
        write(10,'(A70)') '**********************************************************************'
        if(optim%cpt_iter.eq.optim%niter_max) then
           write(10,'(A50)') '  STOP: MAXIMUM NUMBER OF ITERATION REACHED    '
        else
           write(10,'(A50)') '  STOP: CONVERGENCE CRITERION SATISFIED        '
        endif
        write(10,'(A70)') '**********************************************************************'
        close(10)
     elseif(FLAG.eq. 4) then
        write(10,'(A70)') '**********************************************************************'
        write(10,'(A50)') '  STOP: LINESEARCH FAILURE    '
        write(10,'(A70)') '**********************************************************************'
        close(10)     
     elseif(optim%comm.eq. 1) then     
        write(21,'(A90)') '-------------------------------------------------------------------------------------------------'
        write(21,'(A20,I4,A10,ES12.2)') ' NONLINEAR ITERATION ',optim%cpt_iter, ' ETA IS : ',optim%eta
        write(21,'(A90)') '-------------------------------------------------------------------------------------------------'
        write(21,'(A12,A10,A10,A20)')&
             '  Iter_CG      ',&
             '  qk           ',&
             ' norm_res     ',&
             ' norm_res/||gk||  '
        write(21,'(I8,ES12.2,ES12.2,ES12.2)') &
             optim%cpt_iter_CG,&
             optim%qk_CG,&
             optim%norm_residual,&
             optim%norm_residual/optim%norm_grad       
     elseif(optim%comm.eq. 2) then
        write(21,'(I8,ES12.2,ES12.2,ES12.2)') &
             optim%cpt_iter_CG,&
             optim%qk_CG,&
             optim%norm_residual,&
             optim%norm_residual/optim%norm_grad
     else     
        write(10,'(I6,ES12.2,ES12.2,ES12.2,ES12.2,I8,I8,ES12.2,I8,I8)') &
             optim%cpt_iter,&          
             fcost,&
             optim%norm_grad,&
             fcost/optim%f0,&
             optim%alpha,&
             optim%cpt_ls,&
             optim%cpt_iter_CG,&
             optim%eta,&
             optim%nfwd_pb,&
             optim%nhess
     endif
  endif
end subroutine print_info_PTRN

!*****************************************************!
!*          SEISCOPE OPTIMIZATION TOOLBOX            *!
!*****************************************************!
! This routine is the reverse communication mode      !
! preconditioned truncated Newton.                    !
! This algorithm is described in                      !
! L.Metivier, R. Brossier, J. Virieux, S.Operto,      !
! Truncated Newton and full waveform inversion, 2013  !
! SIAM Journal on Scientific Computing, Vol. 35,      !
! No. 2, pp. B401–B437,                               !         
!                                                     !
! This routine performs an iterative                  !
! minimization of a function f following the          !
! recurrence                                          !
!                                                     !
! x_{0}=x0                                            !
! x_{k+1}=x_k+\alpha_k d_k  (1)                       !
!                                                     !
! where the descent direction d_k is computed through !
! the resolution of the preconditioned linear system  !
!                                                     !
! P_k H_k d_k=- P_k\nabla f_k  (2)                    !
!                                                     !
! with H_k        : Hessian operator at iteration k   !
!                                                     !
! with P_k        : Preconditioner                    !
!                                                     !
!\nabla f_k       : gradient of f in x_k              !
!                                                     !
! and alpha_k is the steplength computed through the  !
! common linesearch algorithm of the TOOLBOX          !
!                                                     !
! The linear system (2) is solved through a matrix    !
! free conjugate gradient algorithm which requires the!
! user to perform multiplication of given vector by   !
! the Hessian operator and the preconditioner.        !                     
!                                                     !
! Because of these tow nested algorithms, the reverse !
! communication strategy requires additional          !
! communicators within the code to clearly track which!
! stage the optimizer has reached                     !
!                                                     !
! The first call to the algorithm must be done with   !
! FLAG='INIT'. For this first call, the initial point !
! x0 is given through the variable x, and the input   !
! variable fcost and grad must correspond respectively!
! to the misfit and gradient at x0.                   !
!                                                     !
! The reverse communication with the user is          !
! performed through the variable FLAG. This           !
! variable indicates to the user on return what action! 
! he has to do, or the state of the algorithm.        !
! Possible values are                                 !
! - FLAG='GRAD' => the user must compute the cost,the !
!                  gradient and the preconditioned    !
!                  gradient at current point x in     !
!                  fcost, grad, grad_preco            !
! - FLAG='HESS' => the user must multiply the vector  !
!                  d by the Hessian operator and!
!                  set the result in Hd         !
! - FLAG='PREC' => the user must multiply the vector  !
!                  residual by the              !
!                  preconditioner and set the result  !
!                  in residual_preco            !
! - FLAG='CONV' => a minimizer has been found         !
! - FLAG='NSTE' => a new step is performed            !
! - FLAG='FAIL' => the linesearch has failed          !
!-----------------------------------------------------!
! INPUT  : integer :: n (dimension)                   ! 
!          real fcost (current cost)                  !
!          real,dimension(n) grad                     !
! INPUT/OUTPUT : real,dimension(n) x                  !
!                optim_typ optim (data structure)     !
!                character*4 FLAG (communication)     !
!-----------------------------------------------------!
subroutine PTRN(n,x,fcost,grad,grad_preco,residual,residual_preco, &
                d,Hd,optim,FLAG,lb,ub)
  
  implicit none
  
  !IN
  integer  :: n                                           !dimension of the problem
  real :: fcost                                           !cost associated with x
  real,dimension(n) :: grad                               !gradient at x
  real,dimension(n) :: grad_preco                         !preconditioned gradient at x
  real,dimension(n) :: d, Hd 
  real,dimension(n) :: residual, residual_preco  
  !IN/OUT  
  integer:: FLAG  
  real,dimension(n) :: x                                  !current point
  type(optim_type) :: optim                               !data structure 
  real(c_float),optional, dimension(n) :: lb,ub 
  !Local variable
  logical :: test_conv
  
  if(FLAG.eq. 0) then
     !-----------------------------------------------------!
     ! if FLAG is INIT, call the dedicated initialization  !
     ! subroutine to allocate data structure optim         !
     !-----------------------------------------------------!
     allocate(xk(n), descent(n), descent_prev(n), eisenvect(n))
     xk(:)=x(:)
     optim%norm_grad = norm2 (grad) ! norm of the first gradient
     call print_info_PTRN(optim,fcost,FLAG)     
     optim%comm=1     
     optim%CG_phase=0
     optim%nfwd_pb=optim%nfwd_pb+1
     optim%conv_CG=0
     FLAG=6
  endif
  if(optim%comm.eq. 1) then  
     !-----------------------------------------------------!
     ! if optim%comm is DES1, the optimizer starts the     !
     ! computation of a descent direction through the      !
     ! conjugate gradient                                  !
     !-----------------------------------------------------!
     if(optim%CG_phase.eq. 0) then  
        !-----------------------------------------------------!
        ! if optim%CG_phase is INIT, initialization of the    !
        ! conjugate gradient process
        !-----------------------------------------------------!
        call descent_PTRN0(n,grad,grad_preco,residual,residual_preco,&
                           d,Hd,optim,FLAG)  
        optim%CG_phase=1
        optim%comm=1
        FLAG=7
        optim%nhess=optim%nhess+1
     elseif(optim%CG_phase.eq. 1) then
        !-----------------------------------------------------!
        ! if optim%CG_phase is IRUN, iterate the conjugate    !
        ! gradient process (first part)                       !
        !-----------------------------------------------------!
        call descent_PTRN1(n,grad,residual,residual_preco,d,Hd,optim)    
        if(optim%conv_CG == 1) then 
           !-----------------------------------------------------!
           ! if the conjugate gradient has already converged     ! 
           ! (detection of a negative curvature), go to next     !
           ! phase: linesearch in the descent direction          !
           !-----------------------------------------------------!
           optim%comm=3
           optim%CG_phase=0        
           FLAG=6                   
        else
           !-----------------------------------------------------!
           ! if the conjugate gradient has not converged         ! 
           ! prematurly, then ask the user to apply the          !
           ! preconditioner                                      !
           !-----------------------------------------------------!
           FLAG=8
           optim%comm=2
        endif
     endif
  elseif(optim%comm.eq. 2) then
     !-----------------------------------------------------!
     ! if optim%comm is DES2, the optimizer finish the     !
     ! current iteration of the conjugate gradient process !
     !-----------------------------------------------------!
     call descent_PTRN2(n,grad,residual,residual_preco,d,Hd,optim,FLAG)            
     if(optim%conv_CG == 1) then
        !-----------------------------------------------------!
        ! if the conjugate gradient has converged go to next  !
        ! phase: linesearch in the descent direction          !
        !-----------------------------------------------------!        
        optim%comm=3
        optim%CG_phase=0        
        FLAG=6                
     else
        !-----------------------------------------------------!
        ! else start a new iteration of conjugate gradient and! 
        ! ask the user to compute a Hessian-vector product    !
        !-----------------------------------------------------!        
        optim%comm=1
        FLAG=7
        optim%nhess=optim%nhess+1
     endif
  elseif(optim%comm.eq. 3) then           
     !-----------------------------------------------------!
     ! if optim%comm is NSTE, a descent direction has been !
     ! computed, and a linesearch must be performed in this!
     ! direction                                           !
     !-----------------------------------------------------!
     call std_linesearch(n,x,fcost,grad,xk,descent,optim,lb,ub)     
     if(optim%task.eq. 0) then !NEW STEP                  
        !-----------------------------------------------------!
        ! if optim%task is 'NEW_STEP, the linesearch process  !
        ! has found the new step                              !
        !-----------------------------------------------------!
        optim%cpt_iter=optim%cpt_iter+1
        !Save the previous gradient norm 
        optim%norm_grad_m1=optim%norm_grad
        !Computation of the new gradient norm 
        optim%norm_grad = norm2(grad)
        !Print infor on current nonlinear iteration
        call print_info_PTRN(optim,fcost,FLAG)        
        !Test for convergence
        call std_test_conv(optim,fcost,test_conv)
        if(test_conv) then
           FLAG=2
           call print_info_PTRN(optim,fcost,FLAG)        
           close(10)
           close(21)
           call finalize_PTRN()
        else
           FLAG=3
           !Flag for the computation of the new descent direction
           optim%comm=1       
           !Update forcing term optim%eta following the Eisenstat and Walker formula
           call forcing_term_TRN(n,grad,residual,optim)  
        endif
     elseif(optim%task.eq.1) then 
        !-----------------------------------------------------!
        ! if optim%task is 'NEW_GRAD, the linesearch process  !
        ! is continuing, the gradient at the current point is !
        ! required                                            ! 
        !-----------------------------------------------------!
        FLAG=1         
        optim%nfwd_pb=optim%nfwd_pb+1
     elseif(optim%task.eq. 2) then        
        !-----------------------------------------------------!
        ! if optim%task is 'FAILURE, the linesearch process   !
        ! has failed, the iterations are stopped              !
        !-----------------------------------------------------!
        FLAG=4
        call print_info_PTRN(optim,fcost,FLAG)
        close(10)
        close(21)
        call finalize_PTRN()
     endif
  endif
  
end subroutine PTRN

end module opt_PTRN

!******************************************************************
!Copyright 2013-2016 SEISCOPE II project, All rights reserved.
!
!Redistribution and use in source and binary forms, with or
!without modification, are permitted provided that the following
!conditions are met:
!
!    *  Redistributions of source code must retain the above copyright
!       notice, this list of conditions and the following disclaimer.
!    *  Redistributions in binary form must reproduce the above
!       copyright notice, this list of conditions and the following
!       disclaimer in the documentation and/or other materials provided
!       with the distribution.
!    *  Neither the name of the SEISCOPE project nor the names of
!       its contributors may be used to endorse or promote products
!       derived from this software without specific prior written permission.
!
!Warranty Disclaimer:
!THIS SOFTWARE IS PROVIDED BY THE SEISCOPE PROJECT AND CONTRIBUTORS
!"AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
!LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
!FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
!SEISCOPE PROJECT OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
!INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
!BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
!LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
!CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT,
!STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING
!IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
!POSSIBILITY OF SUCH DAMAGE.

module typedef
use, intrinsic :: iso_c_binding, only: c_float, c_int
implicit none

type, bind(c) :: optim_type
                                                                      
!sequence

!There were changes made to the original derived type in order
!to enable C interoperability and to take things a bit easier.

!-> allocatable arrays were eliminated
!-> logical variables `debug`, `first_ls` and `conv_CG` were changed by integers 
!   zero is interpreted as .FALSE. and one is interpreted as .TRUE.
!-> variables of type character `task`, `CG_phase` and `comm` have been replaced by integers
!-> integer variable `bound` is no longer being used

!#### DEBUG OPTION FOR USER
!# when debug is false: no information printed
!# when debug is true: additional information printed
integer(c_int) :: debug

real(c_float) :: threshold !#tolerance on bound constraints satisfaction

!#### PRINTING FLAG FOR MPI APPLICATION
integer(c_int) :: print_flag

!#### LINESEARCH PARAMETERS
integer(c_int)  :: first_ls
integer(c_int)   :: task !(0 -NEW_STEP, 1 -NEW_GRAD, 2 -FAILURE!)
integer(c_int)   :: nls_max,cpt_ls,nfwd_pb,cpt_iter,niter_max
real(c_float)    :: f0,fk,conv
real(c_float)    :: m1,m2,mult_factor,alpha_L,alpha_R,alpha
real(c_float)    :: q0, q

!### LBFGS PARAMETERS 
integer(c_int) :: cpt_lbfgs,l

!### TRUNCATED NEWTON PARAMETERS
integer(c_int)  :: conv_CG
integer(c_int)   :: cpt_iter_CG,niter_max_CG,nhess
integer(c_int)   :: CG_phase !(0 -INIT, 1 -IRUN)
integer(c_int)   :: comm !(1 -DES1, 2 -DES2, 3 -NSTE)
real(c_float)    :: qk_CG,qkm1_CG,hessian_term,eta,norm_grad,norm_grad_m1,norm_residual

!### PRECONDITIONED TRUNCATED NEWTON PARAMETERS
real(c_float)    :: dHd,res_scal_respreco,alpha_CG

end type optim_type

end module typedef

!*****************************************************************************************
!
!  The main module that uses all the other modules.
!  Allows for a single `use seiscope_optimization_toolbox`
!  to access the entire library.

module seiscope_optimization_toolbox

use typedef
use miscellaneous
use opt_PSTD
use opt_PNLCG
use opt_LBFGS
use opt_PLBFGS
use opt_TRN
use opt_PTRN

implicit none

public

end module seiscope_optimization_toolbox
!*****************************************************************************************

!******************************************************************
!Copyright 2013-2016 SEISCOPE II project, All rights reserved.
!
!Redistribution and use in source and binary forms, with or
!without modification, are permitted provided that the following
!conditions are met:
!
!    *  Redistributions of source code must retain the above copyright
!       notice, this list of conditions and the following disclaimer.
!    *  Redistributions in binary form must reproduce the above
!       copyright notice, this list of conditions and the following
!       disclaimer in the documentation and/or other materials provided
!       with the distribution.
!    *  Neither the name of the SEISCOPE project nor the names of
!       its contributors may be used to endorse or promote products
!       derived from this software without specific prior written permission.
!
!Warranty Disclaimer:
!THIS SOFTWARE IS PROVIDED BY THE SEISCOPE PROJECT AND CONTRIBUTORS
!"AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
!LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
!FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
!SEISCOPE PROJECT OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
!INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
!BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
!LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
!CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT,
!STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING
!IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
!POSSIBILITY OF SUCH DAMAGE.


!*****************************************************!
!*          SEISCOPE OPTIMIZATION TOOLBOX            *!
!*****************************************************!
! This program provides an example for using the      !
! preconditioned nonlinear conjugate gradient         !
! algorithm within the TOOLBOX .                      !
!                                                     !
! The version implemented is the one by               !
! Y. DAI AND Y. YUAN, A nonlinear conjugate gradient  !
! method with a strong global convergence property,   !
! SIAM Journal on Optimization, 10 (1999), pp. 177–182!
!                                                     !
! See also Nocedal, Numerical optimization,           !
! 2nd edition p.132                                   !
!                                                     !
! The 2D Rosenbrock function is minimized             !
! f(x,y)  = (1-x)**2+100.*(y-x**2)**2                 !
!                                                     !
! The computation of this function and its gradient   !
! is implemented in                                   !
! ../../../COMMON/test/rosenbrock.f90                 !
!                                                     !
! The communication with the PNLCG optimizer is       ! 
! achieved through the variable FLAG.                 !
!                                                     !
! Here are the actions requested for the user         !
! 1. Before first call, the user must set the         !
!    optimization parameters, namely                  !
!    - maximum number of iterations optim%niter_max   !
!    - tolerance for the stopping criterion           !
!      (this stopping criterion is the default one    !
!        in the TOOLBOX and is based on the decrease  !
!        of the misfit function scaled to one at the  !
!       first iteration                               !
!     - level of details in the output                !
!       * if optim%debug=.true. then the information  !
!         on the linesearch process is provided       !
!       * if optim%debug=.false. a more compact output!
!         file is provided                            !
!   - initialize x with an arbitrary initial guess    !
!   - initialize fcost with the cost function         !
!     associated with the initial guess               !
!   - initialize grad with the gradient associated    !
!     with the initial guess                          !
!   - initialize grad_preco with the preconditioned   !
!     version of the gradient.                        !
!    %%%%%%%%%%%                                      !
!    %IMPORTANT%                                      !
!    %%%%%%%%%%%                                      !  
!    If the user wants to use the PNLCG algorithm     !
!    WITHOUT preconditioning he has to COPY grad      !
!    in grad_preco                                    !
! 2. On first call, FLAG must be set to INIT          !
! 3. When the FLAG returned by PNLCG is 'GRAD', then  !
!    the user must compute the cost, the gradient and !
!    the preconditioned gradient at current iterate x !
!    %%%%%%%%%%%                                      !
!    %IMPORTANT%                                      !
!    %%%%%%%%%%%                                      !
!    If the user wants to use the PNLCG algorithm     !
!    WITHOUT preconditioning he has to COPY grad in   !
!    grad_preco                                       !
!-----------------------------------------------------!
program test_PNLCG
  !use typedef
  !use opt_PNLCG
  use seiscope_optimization_toolbox
  implicit none  
  
  integer :: n                                ! dimension of the problem
  real :: fcost                               ! cost function value
  real,dimension(:),allocatable :: x          ! current point
  real,dimension(:),allocatable :: grad       ! current gradient
  real,dimension(:),allocatable :: grad_preco ! preconditioned current gradient
  type(optim_type) :: optim                   ! data structure for the optimizer
  !character*4 :: FLAG                         ! communication 
  integer :: FLAG                             ! communication 
  
  !----------------------------------------------------!
  ! Set size of one-dimensional solution array and     !
  ! first flag value                                   !
  !----------------------------------------------------!
  n=2     ! dimension
  FLAG=0  ! first flag -- 'INIT' in original version

  !----------------------------------------------------!
  ! intial guess                                       !
  !----------------------------------------------------!
  allocate(x(n),grad(n),grad_preco(n))
  x(1)=1.5
  x(2)=1.5
  
  !----------------------------------------------------!
  ! computation of the cost and gradient associated    !
  ! with the initial guess                             !
  !----------------------------------------------------!
  call Rosenbrock(x,fcost,grad)

  !----------------------------------------------------!
  ! copy of grad in grad_preco: no preconditioning in  !
  ! this test                                          !
  !----------------------------------------------------!
  grad_preco(:)=grad(:) ! 
  
  !----------------------------------------------------!
  ! parameter initialization                           !
  !----------------------------------------------------!
  call set_inputs(optim, fcost, 10000, 1., 20, 1e-8)
  
  !----------------------------------------------------!
  ! optimization loop: while convergence not reached or!
  ! linesearch not failed, iterate                     !
  !----------------------------------------------------!
  !do while ((FLAG.ne.'CONV').and.(FLAG.ne.'FAIL'))
  do while ((FLAG.ne.2).and.(FLAG.ne.4))
     call PNLCG(n,x,fcost,grad,grad_preco,optim,FLAG)
     !if(FLAG.eq.'GRAD') then 
     if(FLAG.eq.1) then        
        !compute cost and gradient at point x
        call Rosenbrock(x,fcost,grad)
        ! no preconditioning in this test: simply copy grad in 
        ! grad_preco
        grad_preco(:)=grad(:) 
     endif
  enddo
  
  !Helpful console writings
  write(*,*) 'END OF TEST'
  write(*,*) 'FINAL iterate is : ', x(:)
  write(*,*) 'See the convergence history in iterate_CG.dat'
  
end program test_PNLCG

!******************************************************************
!Copyright 2013-2016 SEISCOPE II project, All rights reserved.
!
!Redistribution and use in source and binary forms, with or
!without modification, are permitted provided that the following
!conditions are met:
!
!    *  Redistributions of source code must retain the above copyright
!       notice, this list of conditions and the following disclaimer.
!    *  Redistributions in binary form must reproduce the above
!       copyright notice, this list of conditions and the following
!       disclaimer in the documentation and/or other materials provided
!       with the distribution.
!    *  Neither the name of the SEISCOPE project nor the names of
!       its contributors may be used to endorse or promote products
!       derived from this software without specific prior written permission.
!
!Warranty Disclaimer:
!THIS SOFTWARE IS PROVIDED BY THE SEISCOPE PROJECT AND CONTRIBUTORS
!"AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
!LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
!FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
!SEISCOPE PROJECT OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
!INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
!BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
!LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
!CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT,
!STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING
!IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
!POSSIBILITY OF SUCH DAMAGE.

module miscellaneous
use typedef

public 

contains

subroutine rosenbrock(x,fcost,grad) bind(c, name='rosenbrock')
  
  !IN
  real(c_float),dimension(2) :: x
  !IN/OUT
  real(c_float) :: fcost
  real(c_float),dimension(2) :: grad
 
  fcost=(1-x(1))**2+100.*(x(2)-x(1)**2)**2
  grad(1)=2.*(x(1)-1)-400.*x(1)*(x(2)-x(1)**2)
  grad(2)=200.*(x(2)-x(1)**2)

end subroutine rosenbrock

subroutine rosenbrock_hess(x,d,Hd) bind(c, name='rosenbrock_hess')
  
  !IN
  real(c_float),dimension(2) :: x,d
  !IN/OUT
  real(c_float),dimension(2) :: Hd
  
  Hd(1)=(1200.*x(1)**2-400.*x(2)+2.)*d(1)&
       -400*x(1)*d(2)
  Hd(2)=-400.*x(1)*d(1)+&
       200.*d(2)
  
end subroutine rosenbrock_hess

subroutine set_inputs(optim, fcost, niter_max, &
                      alpha, nls_max, conv, print_flag, &
                      l, niter_max_CG, debug) bind(c, name='set_inputs')
 
  use, intrinsic :: iso_c_binding
  use, intrinsic :: iso_fortran_env, only : real32
  implicit none
  type(optim_type) :: optim !data structure
  real(c_float),intent(in),value            :: fcost 
  real(c_float),intent(in),optional         :: alpha
  real(c_float),intent(in),optional         :: conv
  integer(c_int),intent(in),value           :: niter_max
  integer(c_int),intent(in),optional        :: nls_max
  integer(c_int),intent(in),optional        :: print_flag
  integer(c_int),intent(in),optional        :: l
  integer(c_int),intent(in),optional        :: niter_max_CG
  integer(c_int),intent(in),optional        :: debug
  
  ! tolerance for the stopping criterion
  if (present(conv)) then
   optim%conv=conv
  else ! default:
   optim%conv=epsilon(1._real32)
  endif
  
  ! print info in output files
  if (present(print_flag)) then
   optim%print_flag=print_flag
  else ! default:
   optim%print_flag=1
  endif
  
  ! level of details for output files
  if (present(debug)) then
   optim%debug=debug
  else ! default:
   optim%debug=0
  endif
  
  ! maximum iteration number 
  optim%niter_max=niter_max
  
  !---------------------------------------!
  ! set counters                          !
  !---------------------------------------!
  ! common to all
  optim%cpt_iter=0
  optim%f0=fcost
  optim%nfwd_pb=0  
  ! related to lbfgs/plbfgs
  optim%cpt_lbfgs=1
  ! related to trn/ptrn
  optim%nhess=0
  optim%eta=0.9  
  optim%cpt_iter_CG=0
  
  ! maximum number of stored pairs used for
  ! the l-BFGS approximation
  if (present(l)) then
   optim%l=l
  else ! default:
   optim%l=10
  endif  
  
  ! maximum number of inner conjugate gradient 
  ! iterations
  if (present(niter_max_CG)) then
   optim%niter_max_CG=niter_max_CG
  else ! default:
   optim%niter_max_CG=10
  endif     

  optim%m1=1e-4 ! Wolfe conditions parameter 1 (Nocedal value)
  optim%m2=0.9  ! Wolfe conditions parameter 2 (Nocedal value)
  optim%mult_factor=10 ! Bracketting parameter (Gilbert value)
  optim%fk=fcost
  optim%cpt_ls=0
  optim%first_ls=1

  !---------------------------------------!
  ! initialize linesearch parameters      !
  ! by default, the max number of         !
  ! linesearch iteration is set to 20     !
  ! and the initial steplength is set to 1!
  !---------------------------------------! 
  if (present(alpha)) then
   optim%alpha=alpha
  else ! default:
   optim%alpha=1.
  endif
  
  if (present(nls_max)) then
   optim%nls_max=nls_max
  else ! default:
   optim%nls_max=20
  endif

end subroutine set_inputs

!*******************************************************!
!*    SEISCOPE OPTIMIZATION TOOLBOX                    *!
!*******************************************************!
! This routine is used to generate formatted            !
! ascii output files containing information             !
! on the convergence history.                           !
! The name of these files depend on the                 !
! optimization routine used:                            !
! - steepest descent                : iterate_ST.dat    !
! - nonlinear conjugate gradient    : iterate_CG.dat    !
! - l-BFGS                          : iterate_LB.dat    !
! - preconditioned l-BFGS           : iterate_PLB.dat   !
!                                                       !
! The truncated Newton method and the preconditioned    ! 
! truncated Newont method use their own printing        !
! subroutines to generate their output files since      !
! their format slightly differ.                         !
!                                                       !
! This printing routine is called basically at the      !
! initialization of the optimization and then at each   !
! iteration of the solver                               !
!-------------------------------------------------------!
! INPUT  : character*2 routine_type (solver)            !
!          character*4 FLAG (phase of the solver:       !
!                            initialization,            !
!                            iteration,etc...           !
!          integer n (dimension of the problem)         !
!          optim_type optim (data structure)            !
!-------------------------------------------------------!
subroutine print_info(n,routine_type,optim,fcost,grad,FLAG)

  implicit none

  !IN
  character(len=2) :: routine_type
  !character*4 :: FLAG
  integer :: FLAG
  integer :: n
  real :: fcost
  real,dimension(n) :: grad
  type(optim_type) :: optim !data structure   
  !Local variables
  real :: ng

  if(optim%print_flag.eq.1) then     
     ng= norm2(grad)
     if(FLAG.eq.0) then
        if(routine_type.eq.'ST') then
           open(10,file='iterate_ST.dat')     
           write(10,'(A70)') '**********************************************************************'
           write(10,'(A50)') '         STEEEPEST DESCENT ALGORITHM         '
           write(10,'(A70)') '**********************************************************************'
        elseif(routine_type.eq.'CG') then
           open(10,file='iterate_CG.dat')     
           write(10,'(A70)') '**********************************************************************'
           write(10,'(A50)') '     NONLINEAR CONJUGATE GRADIENT ALGORITHM  '
           write(10,'(A70)') '**********************************************************************'
        elseif(routine_type.eq.'LB') then
           open(10,file='iterate_LB.dat')     
           write(10,'(A70)') '**********************************************************************'
           write(10,'(A50)') '             l-BFGS ALGORITHM                '
           write(10,'(A70)') '**********************************************************************'
        elseif(routine_type.eq.'PL') then
           open(10,file='iterate_PLB.dat')     
           write(10,'(A70)') '**********************************************************************'
           write(10,'(A50)') '             PRECONDITIONED l-BFGS ALGORITHM                '
           write(10,'(A70)') '**********************************************************************'
        endif
        write(10,'(A30,ES10.2)') '     Convergence criterion  : ',optim%conv
        write(10,'(A30,I7)')     '     Niter_max              : ',optim%niter_max
        write(10,'(A30,ES10.2)') '     Initial cost is        : ',optim%f0
        write(10,'(A30,ES10.2)') '     Initial norm_grad is   : ',ng
        write(10,'(A70)') '**********************************************************************'
        write(10,'(A10,A10,A10,A10,A12,A12,A12)')&
             '   Niter   ' ,&
             '   fk      ' ,&
             '   ||gk||  ' ,&
             '     fk/f0   ' ,&
             '       alpha   ' ,&
             '       nls     ',&
             '   ngrad    '
        write(10,'(I6,ES12.2,ES12.2,ES12.2,ES12.2,I8,I8)') &
             optim%cpt_iter,&          
             fcost,&
             ng,&
             fcost/optim%f0,&
             optim%alpha,&
             optim%cpt_ls,&
             optim%nfwd_pb
     elseif(FLAG.eq.2) then
        write(10,'(I6,ES12.2,ES12.2,ES12.2,ES12.2,I8,I8)') &
             optim%cpt_iter,&
             fcost,&
             ng,&
             fcost/optim%f0,&
             optim%alpha,&
             optim%cpt_ls,&
             optim%nfwd_pb
        write(10,'(A70)') '**********************************************************************'
        if(optim%cpt_iter.ge.optim%niter_max) then
           write(10,'(A50)') '  STOP: MAXIMUM NUMBER OF ITERATION REACHED    '
        else
           write(10,'(A50)') '  STOP: CONVERGENCE CRITERION SATISFIED        '
        endif
        write(10,'(A70)') '**********************************************************************'
        close(10)
     elseif(FLAG.eq.4) then
        write(10,'(A70)') '**********************************************************************'
        write(10,'(A50)') '  STOP: LINESEARCH FAILURE    '
        write(10,'(A70)') '**********************************************************************'
        close(10)     
     else
        write(10,'(I6,ES12.2,ES12.2,ES12.2,ES12.2,I8,I8)') &
             optim%cpt_iter,&
             fcost,&
             ng,&
             fcost/optim%f0,&
             optim%alpha,&
             optim%cpt_ls,&
             optim%nfwd_pb    
     endif
  endif
  
end subroutine print_info

!*********************************************!
!*    SEISCOPE OPTIMIZATION TOOLBOX          *!
!*********************************************!
! The routine project compute the projection  !
! of the vector x into the box defined by     !
! the bound constraints optim%lb and optim%ub !
!---------------------------------------------!
! INPUT  : integer n                          !
!          optim_type optim                   !
! IN/OUT : real,dimension(n) x                !
!---------------------------------------------!
subroutine project(n,optim,x,lb,ub)

  implicit none
  
  !IN
  integer :: n
  type(optim_type) :: optim
  !IN/OUT
  real,dimension(n) :: x,ub,lb
  !Local variables
  integer :: i
  
  do i=1,n
     if(x(i).gt.ub(i)) then
        x(i)=ub(i)-optim%threshold
     endif
     if(x(i).lt.lb(i)) then
        x(i)=lb(i)+optim%threshold
     endif
  enddo
  
end subroutine project

!*********************************************!
!*    SEISCOPE OPTIMIZATION TOOLBOX          *!
!*********************************************!
! This routine is the reverse communication   ! 
! mode linesearch shared by all the           ! 
! optimization routines of the toolbox.       !
!                                             !                            
! This linesearch enforces the Wolfe          !
! conditions: sufficient decrease             !
!             sufficient curvature            !
! The Wolfe conditions can be found in        !
! Nocedal, Numerical Optimization, 2nd        !
! edition, p.33                               !
!                                             !
! The linesearch method implemented here is   !
! based first on a bracketing strategy, then  !
! on a dichotomy algorithm. A full description!
! of this strategy can be found in            !
! Numerical Optimizationn Theoretical and     !
! Practical Aspects, J.F.Bonnans, J.C.Gilbert,!
! C. Lemaréchal, C.A. Sagastizábal,           !
! Springer-Verlag, Universitext               !
!                                             !
!---------------------------------------------!
! INPUT  : integer :: n (dimension)           !
!          real fcost (current cost)          !
!          real,dimension(n) grad             !
! OUTPUT : real,dimension(n) x                !
!          optim_typ optim (data structure)   !
!---------------------------------------------!

subroutine std_linesearch(n,x,fcost,grad,xk,descent,optim,lb,ub) !lb,ub,optim
  implicit none

  !IN
  integer :: n
  real :: fcost
  real,dimension(n) :: grad,descent,xk
  !IN/OUT
  real,dimension(n) :: x
  real,optional, dimension(:) :: lb,ub
  type(optim_type) :: optim
  !Local variables
  real :: q0,new_alpha
    
  if(optim%first_ls == 1) then
     !---------------------------------------!
     ! FIRST LINESEARCH: initialization step !
     !---------------------------------------!
     optim%fk=fcost
     q0 = dot_product(grad,descent)
     optim%q0=q0
     !set the search interval bounds to 0
     optim%alpha_L=0.
     optim%alpha_R=0.
     optim%task=1
     optim%first_ls=0
     xk(:)=x(:)
     x(:)=xk(:)+optim%alpha*descent(:)
     !IF BOUNDS ACTIVATED, PROJECT x(:) TO THE FEASIBLE ENSEMBLE
     if(present(lb)) then
        call project(n,optim,x,lb,ub)
     endif
     optim%cpt_ls=0
  elseif( (optim%cpt_ls.ge.optim%nls_max) .and. (fcost<optim%fk)) then     
     !-----------------------------------------------------------------------!
     ! if the number of linesearch iteration outreaches the maximum allowed  !
     ! but a decrease of the misfit is produced then accept the steplength   !
     !-----------------------------------------------------------------------!
     optim%task=0        
     optim%first_ls=1
     !Compute new x in the descent direction     
     x(:)=xk(:)+optim%alpha*descent(:)     
     !IF BOUNDS ACTIVATED, PROJECT x(:) INTO TO THE FEASIBLE ENSEMBLE
     if(present(lb)) then
        call project(n,optim,x,lb,ub)
     endif
  elseif(optim%cpt_ls.ge.optim%nls_max) then     
     !-----------------------------------------------------------------------!
     ! if the number of linesearch iteration outreaches the maximum allowed  !
     ! without decreasing the misfit then the linesearch has failed          !
     !-----------------------------------------------------------------------!
     optim%task=2
  else
     !-----------------------------------------------------------------------!
     ! If not initialization step and number of linesearch iteration ok      !
     ! then perform one linesearch iteration                                 !
     !-----------------------------------------------------------------------!
     optim%q = dot_product(grad,descent)
     if( (fcost.le.(optim%fk+(optim%m1*optim%alpha*optim%q0)))&
          .and.(optim%q.ge.(optim%m2*optim%q0)) ) then
        !--------------------------------------------------------------------!
        ! First test if the Wolfe conditions are satisfied with              !     
        ! current steplength, if this is the case, linesearch                ! 
        ! ends here with success                                             !
        !--------------------------------------------------------------------!
        optim%task=0
        optim%first_ls=1
        if(optim%debug == 1) then
           if(optim%print_flag.eq.1) then
              write(10,*) 'fcost :',fcost
              write(10,*) 'optim%f0 :',optim%f0
              write(10,*) 'optim%fk :',optim%fk
              write(10,*) 'optim%alpha :',optim%alpha
              write(10,*) 'optim%q :', optim%q
              write(10,*) 'optim%q0 :',optim%q0
              write(10,*) 'm1 :',optim%m1
              write(10,*) 'cpt_ls is : ',optim%cpt_ls
           endif
        endif
     elseif (fcost>(optim%fk+(optim%m1*optim%alpha*optim%q0))) then
        !--------------------------------------------------------------------!
        ! If the first condition is not satisfied then shrink the            !
        ! search interval                                                    !
        !--------------------------------------------------------------------!
        if(optim%debug == 1) then
           if(optim%print_flag.eq.1) then
              write(10,*) 'failure 1'
              write(10,*) 'fcost :',fcost
              write(10,*) 'optim%fk :',optim%fk
              write(10,*) 'optim%alpha :',optim%alpha
              write(10,*) 'optim%q0 :',optim%q0
              write(10,*) 'm1 :',optim%m1
              write(10,*) 'cpt_ls is : ',optim%cpt_ls
           endif
        endif
        optim%alpha_R=optim%alpha
        new_alpha=(optim%alpha_L+optim%alpha_R)/2.
        optim%alpha=new_alpha        
        optim%task=1
        optim%cpt_ls=optim%cpt_ls+1
     elseif( (fcost.le. (optim%fk+(optim%m1*optim%alpha*optim%q0)))&
          .and.(optim%q<(optim%m2*optim%q0) ) ) then
        !--------------------------------------------------------------------!
        ! If the second condition is not satisfied then shrink the           !
        ! search interval unless the right bound of the search interval      !
        ! as not yet been defined                                            !
        !--------------------------------------------------------------------!
        if(optim%debug == 1) then
           if(optim%print_flag.eq.1) then
              write(10,*) 'failure 2'
              write(10,*) 'fcost :',fcost
              write(10,*) 'optim%fk :',optim%fk
              write(10,*) 'optim%alpha :',optim%alpha
              write(10,*) 'optim%q0 :',optim%q0
              write(10,*) 'optim%q :',optim%q
              write(10,*) 'm1 :',optim%m1
              write(10,*) 'm2 :',optim%m2
              write(10,*) 'cpt_ls is : ',optim%cpt_ls
           endif
        endif
        optim%alpha_L=optim%alpha
        if(optim%alpha_R .eq. 0.) then
           new_alpha=optim%mult_factor*optim%alpha
        else
           new_alpha=(optim%alpha_L+optim%alpha_R)/2.
        endif
        optim%alpha=new_alpha        
        optim%task=1
        optim%cpt_ls=optim%cpt_ls+1                        
     endif
     !Compute new x in the descent direction
     x(:)=xk(:)+optim%alpha*descent(:)     
     ! IF BOUNDS ACTIVATED, PROJECT x(:) TO THE FEASIBLE ENSEMBLE
     if(present(lb)) then
        call project(n,optim,x,lb,ub)
     endif
  endif
end subroutine std_linesearch



!*********************************************!
!*    SEISCOPE OPTIMIZATION TOOLBOX          *!
!*********************************************!
! This routine implements a simple            !
! convergence test based on the relative      !
! cost  decrease.                             !
! If the current relative cost is lower than  !
! a value set by the user in optim%conv       !
! then test_conv is returned equal to .true.  !
! otherwise, it is returned equal to .false.  ! 
!---------------------------------------------!
! INPUT:  optim_type optim                    !
! OUTPUT: logical test_conv                   !
!---------------------------------------------!
subroutine std_test_conv(optim,fcost,test_conv)

  implicit none

  !IN
  real :: fcost
  type(optim_type) :: optim !data structure   
  !INT/OUT
  logical :: test_conv
    
  test_conv=((fcost/optim%f0<optim%conv).or.&
       (optim%cpt_iter.ge.optim%niter_max))
  
end subroutine std_test_conv

end module miscellaneous
